from report import report_sxw

class aged_partner_report_sisb(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(aged_partner_report_sisb, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'get_empresa': self.get_empresa,
            'lista_apuntes': self.lista_apuntes,
            'sumar_debido':self.sumar_debido,
            'sumar_pagado':self.sumar_pagado,
            'sumar_monto':self.sumar_monto,
            'total_debido':self.get_total_debido,
            'total_pagado':self.get_total_pagado,
            'total_monto':self.get_total_monto,
        })
        self.context = context
        self.cr = cr
        self.uid = uid
        self.total_debido = 0
        self.total_pagado = 0
        self.total_monto = 0
        
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
    
    def lista_apuntes(self,partner_id):
        self.total_debido = 0
        self.total_pagado = 0
        self.total_monto = 0
        qry = """
                SELECT l.id as id, 
                CASE WHEN length(account_move.name) > 20 THEN 
                    left(account_move.name, 20) || ' ' || substr(account_move.name, 20) 
                ELSE account_move.name END  as documento, 
                CASE WHEN length(account_move.ref) > 20 THEN 
                    left(account_move.ref, 20) || ' ' || substr(account_move.ref, 20) 
                ELSE account_move.ref END as referencia, 
                account_move.date, l.date_maturity as fecha_vencimiento, 
                CASE WHEN l2.days_due < 0 THEN 0 ELSE l2.days_due END as dias_vencidos,
                 l.debit as debido, l. credit as pagado, l.debit -l. credit as monto, amr.name
                            FROM account_move_line l
                            INNER JOIN
                               (
                                   SELECT id, EXTRACT(DAY FROM (now() - COALESCE(lt.date_maturity,lt.date))) AS days_due
                                   FROM account_move_line lt
                               ) l2
                               ON l2.id = l.id
                            INNER JOIN account_account
                               ON account_account.id = l.account_id
                            INNER JOIN res_company
                               ON account_account.company_id = res_company.id
                            INNER JOIN account_move
                               ON account_move.id = l.move_id
                            LEFT OUTER JOIN account_move_reconcile amr on l.reconcile_partial_id = amr.id
                            WHERE account_account.active
                                  AND (account_account.type IN ('receivable'))
                                  AND (l.reconcile_id IS NULL)
                                  AND account_move.state = 'posted'
                               AND l.reconcile_id is null
                               AND l.partner_id = %s
                order by amr.name, account_move.date
                """%(partner_id.id)
        self.cr.execute(qry)
        apuntes = self.cr.dictfetchall()

        return apuntes
        
    def sumar_debido(self, debido):
        if debido:
            self.total_debido += debido
        return debido

    def sumar_pagado(self, pagado):
        if pagado:
            self.total_pagado += pagado
        return pagado

    def sumar_monto(self, monto):
        if monto:
            self.total_monto += monto
        return monto

    def get_total_debido(self):
        return self.total_debido

    def get_total_pagado(self):
        return self.total_pagado
        
    def get_total_monto(self):
        return self.total_monto



report_sxw.report_sxw(
    'report.sisb.aged.partner.report',
    'account.aged.partner.balance.vw',
    'account_aged_partner_balance_vw_sisb/report/aged_partner_report.rml',
    parser=aged_partner_report_sisb, header=False
)
