#!/usr/bin/python
# -*- encoding: utf-8 -*-



import time
from report import report_sxw
from osv import osv
import pooler

class comprobante_contable(report_sxw.rml_parse):
    
    
    def __init__(self, cr, uid, name, context):
        super(comprobante_contable, self).__init__(cr, uid, name, context)    
        self.localcontext.update({
            'time': time,
            'suma': self.suma,
            'get_empresa': self.get_empresa,
        })
        
        
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
    
    
    def suma(self, line):

        result = {'credito':0.0,'debito':0.0}

        for row in line:

                if row.debit:
                    result['debito'] += row.debit
                if row.credit:
                    result['credito'] += row.credit


        return result
        
report_sxw.report_sxw(
    'report.account.move.report',
    'account.move',
    'account_move_report/report/comprobante.rml',
    parser=comprobante_contable,
    header=False
)      

