# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
 
import time
from report import report_sxw
#~ from tools import amount_to_text
from numero_a_texto import Numero_a_Texto

class report_voucher_print(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(report_voucher_print, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'time': time,
            'get_title': self.get_title,
            'get_lines':self.get_lines,
            'get_on_account':self.get_on_account,
            'convertir':self.convertir,
            'get_iva':self.get_iva,
            'get_crs':self.get_crs,
        })


    def convertir(self,amount):
        number_str=str(amount)
        number_str=number_str.replace(",", "")
        number_int, number_dec = number_str.split(".")
        res=Numero_a_Texto(number_int)
        res2=Numero_a_Texto(number_dec)
        return "%s CON %s CENTIMOS"%(res,res2)


    def get_lines(self, voucher):
        res={}
        for lines in voucher:
            if res.get("cuenta"):    
                if res['cuenta'] == lines.account_id.name:
                    res['monto'] += lines.amount
                    res['codigo'] = lines.account_id.code

            else:
                res['monto'] = lines.amount
                res['cuenta'] = lines.account_id.name
                res['codigo'] = lines.account_id.code

        return res
        


    def get_title(self, type):
        title = ''
        if type:
            title = type[0].swapcase() + type[1:] + " Comprobante"
        return title

    def get_on_account(self, voucher):
        name = ""
        if voucher.type == 'receipt':
            name = "Recibe dinero de "+str(voucher.partner_id.name)
        elif voucher.type == 'payment':
            name = "Pago de "+str(voucher.partner_id.name)
        elif voucher.type == 'sale':
            name = "Venta de "+str(voucher.partner_id.name)
        elif voucher.type == 'purchase':
            name = "Compra de "+str(voucher.partner_id.name)
        return name
        
    def get_iva(self, voucher_line):
        l=0.0
        for line in voucher_line.invoice_id.wh_iva_id.wh_lines:
            l += line.amount_tax_ret
        return str(l)
        
    def get_crs(self, invoice):
        l=0.0
        if not invoice.wh_src_id:
             return "0.00"
        
        for line in invoice.wh_src_id.line_ids:
            if line.invoice_id.id == invoice.id:
                l += line.wh_amount
                
        if l == 0.0:
            return "0.00"
        return str(l)
    
report_sxw.report_sxw(
    'report.voucher.print.sisb',
    'account.voucher',
    'bm_comprobante_pago/report/account_voucher_print.rml',
    parser=report_voucher_print,header="external"
)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
