#~ # -*- coding: utf-8 -*-
from report import report_sxw
import time
from datetime import datetime, timedelta


class comprobante_report(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        
        super(comprobante_report, self).__init__(cr, uid, name, context)
        self.localcontext.update(
        {
            'agrupar': self.agrupar,
            'valor':self.valor,
            'valor1':self.valor1,
            'valor2':self.valor2,
            'valor3':self.valor3,
            'debit':self.debit,
            'credit':self.credit,
            'get_payee':self.get_payee,
                    })
        self.context= context

    def get_payee(self, voucher):
        payee=""
        if voucher.payee_id: #si existe un beneficiario se toma este si no se toma la comania 
            payee=voucher.payee_id.name
        else:#la compania
            payee=voucher.partner_id.name
        return payee

    def debit(self, move_ids):
        debit = 0.0
        for move in move_ids:#self.pool.get('account.move.line').browse(self.cr, self.uid, move_ids):
            debit +=move.debit
        return debit

    def credit(self, move_ids):
        credit = 0.0
        for move in move_ids:#self.pool.get('account.move.line').browse(self.cr, self.uid, move_ids):
            credit +=move.credit
        return credit


    def valor(self, valor):
        return valor['code']

    def valor1(self, valor1):
        return valor1['name']

    def valor2(self, valor2):
        return valor2['debit']

    def valor3(self, valor3):
        return valor3['credit']
        
        
    def agrupar(self,form):
        di= {}
        for move_l in form: 
            if di.get(str(move_l.account_id.id)):
                di[str(move_l.account_id.id)]['debit'] += move_l.debit
                di[str(move_l.account_id.id)]['credit']+= move_l.credit
            else:
                dos = {
                'debit':move_l.debit,
                'credit':move_l.credit,
                'code':move_l.account_id.code,
                'name':move_l.account_id.name,
                }
                di[str(move_l.account_id.id)] = dos
    
            
        data = []    
        for val in di.keys():
            data.append(di[val])
        return data

  
report_sxw.report_sxw('report.cash_receipt.drcr.4',
                    'voucher.pay.support',
                    parser= comprobante_report,
                    #~ header= 'internal',
                    rml= 'bm_comprobante_pago/report/report_voucher.rml'
                    )
