#!/usr/bin/python
# -*- encoding: utf-8 -*-
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################
from osv import osv
from osv import fields
from tools.translate import _
import decimal_precision as dp
import time
######################Soporte de Pago##########################

class voucher_pay_support(osv.osv):
    _inherit='voucher.pay.support'

    _columns={
        'name':fields.char('Acknowledgment of receipt',size=256, required=False, readonly=False ,
                    states={
                    'draft':[('readonly',False)],
                    'to_draw':[('readonly',True)],
                    'open':[('readonly',True)],
                    'done':[('readonly',True)],
                    'cancel':[('readonly',True)]}),
        'state': fields.selection([
            ('draft','Draft'),
            ('to_draw','To Draw'),
            ('open','Open'),
            ('done','Done'),
            ('cancel','Cancel'),
            ],'State', select=True, readonly=True, help="State Voucher Check Note"),
        'cancel_check_note': fields.selection([
            ('print','Print Error'),
            ('perdida','Loss or misplacement'),
            ('dan_fis','Physical damage'),
            ('pago','Payment is not made'),
            ('devuelto','Returned check'),
            ('caduco','Expired'),
            ('otros','Other'),
            ],'Reason for Cancellation', select=True, readonly=True,
                        states={'draft':[('readonly',False)],
                        'to_draw':[('readonly',True)],
                        'open':[('readonly',False)],
                        'cancel':[('readonly',True)],
                        'done':[('readonly',True)]}),
        'notes':fields.char('Note',size=256, required=False, readonly=False ,
                        states={'draft':[('readonly',False)],
                        'to_draw':[('readonly',True)],
                        'open':[('readonly',False)],
                        'cancel':[('readonly',True)],
                        'done':[('readonly',True)]}),
     }

    def get_firmar(self, cr, uid, ids, context=None):
        soporte = self.browse(cr,uid,ids)
        for i in soporte:
            if i.cancel_check_note or i.notes:
                raise osv.except_osv(_('Alert !'), _('Remove the reason for cancellation'))
            else:
                if i.name:
                    self.write(cr,uid,i.id,{'state' : 'to_draw', 'name':i.name })
                    account_voucher = self.pool.get('account.voucher')
                    account_voucher.proforma_voucher(cr, uid,  [i.check_note_id.account_voucher_id.id], context=context)
                else:
                    raise osv.except_osv(_('Alert !'), _('Enter the acknowledgment'))
        return True
        
    def get_retirado_new(self, cr, uid, ids, context={}):
        if context is None:
            context = {}
        soporte = self.browse(cr,uid,ids)
        for i in soporte:
            self.write(cr,uid,i.id,{'state' : 'open'})
        return True

    #~ def get_cancelar(self, cr, uid, ids, context={}):
        #~ if context is None:
            #~ context = {}
        #~ soporte = self.browse(cr,uid,ids)
        #~ cheque = self.pool.get('check.note')
        #~ account_voucher = self.pool.get('account.voucher')
        #~ for i in soporte:
            #~ self.write(cr,uid,i.id,{'state' : 'cancel'})
            #~ account_voucher.write(cr, uid, [i.check_note_id.account_voucher_id.id],{'state':'proforma'})
            #~ cheque.write(cr, uid, [i.check_note_id.id],{'state':'cancel','cancel_check_note':'devuelto'})
        #~ return True

voucher_pay_support()



class account_voucher(osv.osv):
    _inherit="account.voucher"
    _columns={
        'state':fields.selection(
            [('draft','Draft'),
             ('proforma','Pro-forma'),
             ('in_process','In Process'),
             ('posted','Posted'),
             ('cancel','Cancelled')
            ], 'State', readonly=True, size=32,
            help=' * The \'Draft\' state is used when a user is encoding a new and unconfirmed Voucher. \
                        \n* The \'Pro-forma\' when voucher is in Pro-forma state,voucher does not have an voucher number. \
                        \n* The \'Posted\' state is used when user create voucher,a voucher number is generated and voucher entries are created in account \
                        \n* The \'Cancelled\' state is used when user cancel voucher.'),
    }
account_voucher()
