#!/usr/bin/python
# -*- encoding: utf-8 -*-
###########################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################

from osv import fields, osv
import tools
from tools.translate import _
from tools import config

class cancel_voucher_pay_support(osv.osv_memory):
    _inherit = "cancel.voucher.pay.support"

    _columns = {
        'state': fields.selection([
            ('draft','Draft'),
            ('to_draw','To Draw'),
            ('open','Open'),
            ('done','Done'),
            ('cancel','Cancel'),
            ],'State', select=True, readonly=True, help="State Voucher Check Note"),
    }

    def cancel_cheque_draft(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        
        cancel_cheque = self.browse(cr,uid,ids[0])
        cheque = self.pool.get('check.note')
        account_voucher = self.pool.get('account.voucher')
        voucher_pay_support = self.pool.get('voucher.pay.support')
        
        id = context["active_id"]
        account_voucher_id = account_voucher.search(cr, uid, [('voucher_pay_support_id','=',id)])[0]
        obj_account_voucher = account_voucher.browse(cr, uid, account_voucher_id, context=None)
        obj_voucher_pay_support = voucher_pay_support.browse(cr, uid, id, context=None)
        cancelar = cancel_cheque.cancel_check_note
        nota = cancel_cheque.notes
        
        #se cambia el documento a estado a cancel
        voucher_pay_support.write(cr,uid,id,
                                {'state' : 'cancel' , 
                                'cancel_check_note': cancel_cheque.cancel_check_note , 
                                'notes':cancel_cheque.notes, 
                                'return_voucher_id':account_voucher_id})
                                   
        #se cambia el cheque a estado cancelado
        cheque.write(cr,uid,obj_voucher_pay_support.check_note_id.id,
                                {'state' : 'cancel',
                                'cancel_check_note': cancel_cheque.cancel_check_note,
                                'notes':cancel_cheque.notes })
        
        #se cambia el estado del account.voucher a pro-forma
        account_voucher.write(cr, uid, [account_voucher_id],{'state':'proforma'})
        
        return {'type': 'ir.actions.act_window_close'}

cancel_voucher_pay_support()
