#!/usr/bin/python
# -*- encoding: utf-8 -*-
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##############################################################################

from osv import fields, osv
import tools
from tools.translate import _
from tools import config

class voucher_pay_support_wizard(osv.osv_memory):
    _inherit = "voucher.pay.support.wizard"
    
    _columns = {
        'state': fields.selection([
            ('draft','Draft'),
            ('to_draw','To Draw'),
            ('open','Open'),
            ('done','Done'),
            ('cancel','Cancel'),
            ],'State', select=True, readonly=True, help="State Voucher Check Note"),
    }

    def pop_check(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        
        if not context.has_key('lprtxt'):
            context['lprtxt'] = True
        obj = self.browse(cr, uid, ids[0])
        created_account_voucher = []  
        if context.get('lprtxt') and obj.bool_sure or not context.get('lprtxt'): #si selecciono la opcion estas seguro?
            if context.get('lprtxt') and obj.bool_bad: #si el cheque esta malo
                vista="view_voucher_pay_support_wizard_escribir_nota" #muestra la interface para escribir la razon en la nota
            else: #si el cheque esta bien
                if context.get('lprtxt') and obj.bool_bad==False and obj.bool_good == False: #no selecciono ninguna opcion
                    raise osv.except_osv(_('Alert !'), _('Enter at least one choice!!!'))
                check_note = self.pool.get('check.note') 
                payee_id = self.pool.get('res.partner.address')
                accounting_bank_id = self.pool.get('res.partner.bank')
                bank_id = self.pool.get('res.bank') 
                contrapartida = self.pool.get('res.partner') 
                compania = self.pool.get('res.company')
                account_voucher = self.pool.get('account.voucher')

                obj_check_note=check_note.browse(cr, uid, context["check_note_id"], context=None)
                payee=False   
                if context.get('payee_id',False):
                    obj_payee_id=payee_id.browse(cr, uid, context["payee_id"], context=None)
                    payee=obj_payee_id.id

                obj_accounting_bank_id=accounting_bank_id.browse(cr, uid, context["accounting_bank_id"], context=None)
                obj_bank_id= bank_id.browse(cr, uid, context["bank_id"], context=None)
                obj_contrapartida=contrapartida.browse(cr, uid, context["partner_id"], context=None)
                obj_compania=compania.browse(cr, uid, context["company_id"], context=None)
                obj_account_voucher=account_voucher.browse(cr, uid, context["account_voucher_id"], context=None)
                #se hace el cambio (WRITE) del estado del cheque (asignado)
                obj_check_note.write({'state':"assigned"}) 
                #Se crea el documento (CREATE) voucher.pay.support con los datos "Soporte de Pago"
                voucher_pay=self.pool.get('voucher.pay.support')
                voucher_pay_id=voucher_pay.create(cr, uid,{
                                'check_note_id':obj_check_note.id,
                                'company_id': obj_compania.id,
                                'partner_id': obj_contrapartida.id,
                                'type': 'check',
                                'amount': context["amount"],
                                'date': context["date"],
                                'payee_id':payee,
                                'accounting_bank_id':obj_accounting_bank_id.id,
                                },context=None)
                ids2=[]
                ids2.append(context["account_voucher_id"])
                #Se guarda el account_voucher y se cambia el estado a "en proceso"
                obj_account_voucher.write({'voucher_pay_support_id':voucher_pay_id,'state':'in_process'})
                #Se escribe el diario y la cuenta contable en el modelo accout_voucher
                #cuando existen cuentas transitorias
                transitory=self.pool.get('res.users').browse(cr, uid, uid, context=context).company_id.transitory
                if transitory== False: 
                    obj_account_voucher.write({'account_id':obj_accounting_bank_id.bank_account_id.id, 'journal_id': obj_accounting_bank_id.journal_id.id })
                else: #cuenta transitoria
                    cuenta_transitoria=obj_accounting_bank_id.trans_account_id
                    if cuenta_transitoria:
                        obj_account_voucher.write({'account_id':obj_accounting_bank_id.trans_account_id.id, 'journal_id': obj_accounting_bank_id.journal_id.id })
                    else:
                        raise osv.except_osv(_('Alert !'), _('You have to enter the transitory bank account: %s')%(obj_accounting_bank_id.bank.name))
                    
                #Se hace un write de check_note el campo account_voucher_id
                obj_check_note.write({'account_voucher_id':obj_account_voucher.id})
                #Se redirecciona la ventana al tree
                mod_obj = self.pool.get('ir.model.data')
                act_obj = self.pool.get('ir.actions.act_window')
                xml_id = 'action_pay_order_wizard_soporte'
                result = mod_obj._get_id(cr, uid, 'bank_management', xml_id)
                id = mod_obj.read(cr, uid, result, ['res_id'])['res_id']
                result = act_obj.read(cr, uid, id)
                created_account_voucher.append(voucher_pay_id)
                result['res_id'] = created_account_voucher
                return result
        else: #si no selecciono la opcion estas seguro?
            vista="view_voucher_pay_support_wizard_preguntar"
        obj_model = self.pool.get('ir.model.data')
        model_data_ids = obj_model.search(cr,uid,[('model','=','ir.ui.view'),('name','=',vista)])
        resource_id = obj_model.read(cr, uid, model_data_ids, fields=['res_id'])[0]['res_id']
        return {
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'voucher.pay.support.wizard',
            'views': [(resource_id,'form')],
            'type': 'ir.actions.act_window',
            'target': 'new',
            'context': context,
        }
voucher_pay_support_wizard()
