#~ # -*- coding: utf-8 -*-
from report import report_sxw
import time
from datetime import datetime, timedelta
import datetime as dt


class almacenes_albaranes(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        
        super(almacenes_albaranes, self).__init__(cr, uid, name, context)
        self.localcontext.update(
        {
            'get_empresa':self.get_empresa,
            'get_data': self._get_data,
            'get_final_date': self._get_final_date,
            'get_total': self._get_total,
            'get_cantidad': self._get_cantidad,
            'get_precio': self._get_precio,
           
                    })
        self.context= context
        

    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
        
           
    def _get_final_date(self):
        datetime.now().strftime('%d-%m-%Y %H:%M')
        return datetime.now().strftime('%d-%m-%Y %H:%M')

        
    def _get_data(self,form):
        d1=form['date_from']
        d2=form['date_to']
        u= self.pool.get('stock.location').read(self.cr, self.uid, form['ubicacion'],['id'])['id']
        tipo = form['tipo']
        
        data=[]

        self.cr.execute("""
            Select * from (
            select pp.default_code as referencia,
            pp.name_template as producto,
            sm.product_qty as cantidad, 
            sm.price_unit as precio, 
            sm.product_qty*sm.price_unit as subtotal, sl.name as Origen, sld.name as Destino, sp.type as tipo
            from stock_move sm 
            inner join stock_picking sp on sp.id = sm.picking_id
            inner join product_product pp on sm.product_id = pp.id
            inner join stock_location sl on sl.id = sm.location_id
            inner join stock_location sld on sld.id = sm.location_dest_id
            where (sm.location_id = %s or sm.location_dest_id = %s) 
            and (sm.state = 'done') and (sm.date  BETWEEN '%s' AND '%s')
            and (sp.type = '%s')
            )  tbl
            order by tbl.cantidad desc, tbl.tipo, tbl.referencia
            """%(u,u,d1,d2,tipo))

        data = self.cr.dictfetchall()
        return data

    def _get_total(self,form):
        d1=form['date_from']
        d2=form['date_to']
        u= self.pool.get('stock.location').read(self.cr, self.uid, form['ubicacion'],['id'])['id']
        tipo = form['tipo']
        
        total=[]

        self.cr.execute("""
            Select sum(subtotal) as total from (
            select pp.default_code as referencia,
            pp.name_template as producto,
            sum(sm.product_qty) as cantidad, 
            sm.price_unit as precio, 
            sum(sm.product_qty*sm.price_unit) as subtotal, sl.name as Origen, sld.name as Destino, sp.type as tipo
            from stock_move sm 
            inner join stock_picking sp on sp.id = sm.picking_id
            inner join product_product pp on sm.product_id = pp.id
            inner join stock_location sl on sl.id = sm.location_id
            inner join stock_location sld on sld.id = sm.location_dest_id
            where (sm.location_id = %s or sm.location_dest_id = %s) 
            and (sm.state = 'done') and (sm.date  BETWEEN '%s' AND '%s')
            and (sp.type = '%s')
            group by pp.default_code, pp.name_template, sm.price_unit, sl.name, sld.name, sp.type)  tbl
            """%(u,u,d1,d2,tipo))

        total= self.cr.dictfetchall()[0]['total']
        return total
        
        return data

    def _get_cantidad(self,form):
        d1=form['date_from']
        d2=form['date_to']
        u= self.pool.get('stock.location').read(self.cr, self.uid, form['ubicacion'],['id'])['id']
        tipo = form['tipo']
        
        cantidad=[]

        self.cr.execute("""
            Select sum(cantidad) as cantidad_total from (
            select pp.default_code as referencia,
            pp.name_template as producto,
            sum(sm.product_qty) as cantidad, 
            sm.price_unit as precio, 
            sum(sm.product_qty*sm.price_unit) as subtotal, sl.name as Origen, sld.name as Destino, sp.type as tipo
            from stock_move sm 
            inner join stock_picking sp on sp.id = sm.picking_id
            inner join product_product pp on sm.product_id = pp.id
            inner join stock_location sl on sl.id = sm.location_id
            inner join stock_location sld on sld.id = sm.location_dest_id
            where (sm.location_id = %s or sm.location_dest_id = %s) 
            and (sm.state = 'done') and (sm.date  BETWEEN '%s' AND '%s')
            and (sp.type = '%s')
            group by pp.default_code, pp.name_template, sm.price_unit, sl.name, sld.name, sp.type)  tbl
            """%(u,u,d1,d2,tipo))

        cantidad= self.cr.dictfetchall()[0]['cantidad_total']
        return cantidad
        
    def _get_precio(self,form):
        d1=form['date_from']
        d2=form['date_to']
        u= self.pool.get('stock.location').read(self.cr, self.uid, form['ubicacion'],['id'])['id']
        tipo = form['tipo']
        
        precio=[]

        self.cr.execute("""
            Select sum(precio) as precio_total from (
            select pp.default_code as referencia,
            pp.name_template as producto,
            sum(sm.product_qty) as cantidad, 
            sm.price_unit as precio, 
            sum(sm.product_qty*sm.price_unit) as subtotal, sl.name as Origen, sld.name as Destino, sp.type as tipo
            from stock_move sm 
            inner join stock_picking sp on sp.id = sm.picking_id
            inner join product_product pp on sm.product_id = pp.id
            inner join stock_location sl on sl.id = sm.location_id
            inner join stock_location sld on sld.id = sm.location_dest_id
            where (sm.location_id = %s or sm.location_dest_id = %s) 
            and (sm.state = 'done') and (sm.date  BETWEEN '%s' AND '%s')
            and (sp.type = '%s')
            group by pp.default_code, pp.name_template, sm.price_unit, sl.name, sld.name, sp.type)  tbl
            """%(u,u,d1,d2,tipo))

        precio= self.cr.dictfetchall()[0]['precio_total']
        return precio
        

 
report_sxw.report_sxw('report.albaran.stock.picking',
                    'stock.picking',
                     parser= almacenes_albaranes,
                    #~ header= 'internal',
                    rml= 'diana_almacenes/report/albaranes.rml'
                    )
