#~ # -*- coding: utf-8 -*-
from report import report_sxw
import time
from datetime import datetime, timedelta


class almacen_report(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        
        super(almacen_report, self).__init__(cr, uid, name, context)
        self.localcontext.update(
        {
            'get_data': self._get_data,
            'get_final_date': self._get_final_date,


                    })
        self.context= context


            
    def _get_final_date(self):
        datetime.now().strftime('%d-%m-%Y %H:%M')
        return datetime.now().strftime('%d-%m-%Y %H:%M')

        
    def _get_data(self,form):
        d1=form['date_from']
        d2=form['date_to']
        data=[]


        self.cr.execute("""
            select sp.name as referencia, pp.default_code as codigo, pp.name_template as producto,
            rp.name as empresa, sm.product_qty as cantidad, uom.name as unidad, sl.name as ubi_origen, 
            sl1.name as ubi_destino, sm.date as fecha, sm.price_unit as precio_und
            from stock_picking sp 
            inner join stock_move sm on sp.id = sm.picking_id 
            inner join stock_location sl on sl.id = sm.location_id
            inner join stock_location sl1 on sl1.id = sm.location_dest_id 
            inner join account_move am on am.ref = sp.name
            inner join account_move_line aml on am.id = aml.move_id and sm.product_id = aml.product_id 
            and sm.product_qty = aml.quantity
            inner join product_product pp on pp.id = sm.product_id
            left outer join res_partner rp on sp.partner_id = rp.id 
            inner join product_template pt on pt.id = pp.product_tmpl_id
            inner join product_uom uom on uom.id = pt.uom_id
            where sp.state= 'done' and 
            sp.name = aml.ref and aml.credit <> 0.0 
            and sm.date>= '%s' and sm.date<= '%s' 
        """%(d1,d2))


        data = self.cr.dictfetchall()
       
        return data

  
report_sxw.report_sxw('report.report.wizard.almacenes',
                    'stock.picking',
                    'diana_almacenes/report/report_wizard_almacenes.rml',
                    parser= almacen_report,
                    #~ header= 'internal',

                    )
