# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
#~ 
from osv import osv
from osv import fields
import sys
from tools.translate import _
import time


class report_wizard_almacenes(osv.osv_memory):
    _name = "report.wizard.almacenes"
    _description = "Report Wizard almacenes"

    _columns = {
        'date_from': fields.date("Date", required=True),
        'date_to': fields.date("Date", required=True),
        'ubicacion': fields.many2one('stock.location','ubicacion', required=True),
        'tipo' : fields.selection([('in','Albaran de entrada'),('internal','Albaran interno'),('out','Albaran de salida')],'Tipo'),
        }
    _defaults = {
        'date_from': lambda *a: time.strftime('%Y-%m-%d'),
        'date_to': lambda *a: time.strftime('%Y-%m-%d'),
        'ubicacion': None,
        'tipo': "t",

        }

    def report_wizard_almacenes_stock(self, cr, uid, ids, data, context=None):

        data['form'] = self.read(cr, uid, ids,['date_from','date_to','ubicacion','tipo'])[0]
        return {'type': 'ir.actions.report.xml', 'report_name': 'albaran.stock.picking', 'datas': data}
        

  

report_wizard_almacenes()
