# -*- coding: utf-8 -*-
from osv import osv, fields
import time
from tools.translate import _


class diana_stock_procurement_service(osv.osv_memory):
        
        _name = 'diana.stock.procurement.service'
        _description = 'Servicios'
        
        _columns = {
        'name': fields.char('Referencia de Abastecimiento', size=129),
        'diana_stock_procurement_id':fields.many2one('diana.stock.procurement', 'ID Orden'),  
        'product_id': fields.many2one('product.product', 'Servicio', required=True),
        'product_qty': fields.float('Cantidad', required=True),
        'product_uom': fields.many2one('product.uom', 'UDM del Servicio', required=True),
        'location_id': fields.many2one('stock.location', 'Ubicacion', required=True),
        'date_planned': fields.datetime('Fecha', required=True),
        'note': fields.text('Note', required=True),  
        }
        
        _defaults = {
        'name': 'Solicitud de Servicio',
        }
        
        def agregar_servicio(self, cr, uid, ids, context=None):
            service = self.browse(cr, uid, ids)
            
            diana_stock_procurement_obj = self.pool.get('diana.stock.procurement')
            diana_stock_procurement_brw = diana_stock_procurement_obj.browse(cr, uid, (context['diana_stock_procurement_id'][0]))
            for line in service:
                    
                procurement_order = {
                            'name':'Orden de Servicio',
                            'diana_stock_procurement_id':int(context['diana_stock_procurement_id'][0]), 
                            'origin': context['origin'][0]['name'], 
                            'product_id':  line.product_id.id,
                            'product_qty': line.product_qty,
                            'product_uom': line.product_uom.id,
                            'location_id': line.location_id.id,
                            'date_planned':line.date_planned,
                            'note': line.note,      
                }
                
            obj_procurement = self.pool.get('procurement.order')
            procurement_order_id = obj_procurement.create(cr,uid,procurement_order)
            res_id = self.pool.get('ir.model.data').search(cr,uid,[('model','=','ir.ui.view'),('name','=','abastecimiento_form_view')])
            resource_id = self.pool.get('ir.model.data').read(cr, uid, res_id, fields=['res_id'])[0]['res_id']
            context.update({'procurement_order_id':procurement_order_id})
            return { 
            'view_type': 'form',
            'view_mode':'form',
            'res_model': 'diana.stock.procurement',
            #~ 'views': [(resource_id,'form')], #Comentar en caso de que no funcione
            'type': 'ir.actions.act_window',
            'target': 'edit',
            'context': context,
            'res_id': int(context['diana_stock_procurement_id'][0]),
            'ref': 'diana_almacenes.abastecimiento_form_view',
            }
            #{'type':'ir.actions.act_window_close'}
            
        def on_change_product_id(self, cr, uid, ids, product_id, uom=False):
            """ On change of product id.
            @param product_id: Changed Product id
            @param uom: Changed Product uom
            @return: Dictionary of values
            """
            context = {}   
            if product_id :
                product_uom = self.pool.get('product.product').browse(cr, uid, product_id)
                result = {'product_id': product_id, 'product_uom': product_uom.uom_id.id}
            else:
                result = {'product_id': product_id, 'product_uom': uom}
            return {'value':result}
        
        def onchange_location_id(self, cr, uid, ids, loc_id=False):
            """ On change of location_id and location_dest_id.
            @param loc_id: Source location id
            @return: Dictionary of values
            """
            context = {}
            if bool(loc_id) & (uid <> 1): 
                location = self.pool.get('stock.location')._get_location_allowed(cr, uid, loc_id, context)
                if location.get(loc_id) is None:
                    return {'value':{'location_id': False},
                            'warning': {'title':'Atención','message':'Ubicación no permitida'}  }
                
                elif location[loc_id] == 'No':
                    return {'value':{'location_id': False},
                            'warning': {'title':'Atención','message':'Ubicación no permitida'}  }
                
            wh_ = self.pool.get('stock.warehouse').search(cr, uid, [('lot_input_id', '=', loc_id)])
            if wh_ == []:
                return {'value':{'location_id': False},
                        'warning': {'title':'Atención','message':'La ubicación no tiene un almacén asociado'}  }
                            
            return {'value':{'location_id': loc_id}}
            

diana_stock_procurement_service()
