# -*- coding: utf-8 -*-
from osv import osv, fields
import decimal_precision as dp
import netsvc
import pooler
from tools.translate import _


class account_invoice(osv.osv):
    _inherit = "account.invoice"
    
    def validar_account_invoice_line_islr_concept(self, cr, uid, ids):
        """Funcion para validar que la factura no se le apruebe 
        si el proveedor es exento de retencion de ISLR y 
        alguna de las lineas de la factura tiene concepto de retencion asociado.
        Se asume que existe el concepto NO APLICA RETENCION.
        Adicionalmente se valida que se registre concepto de retencion 
        si es una factura de compras (in_invoice) o una nota de credito (in_refund)"""
        ai_brw = self.browse(cr, uid, ids)
        for inv in ai_brw:
            partner_exento = inv.partner_id.islr_exempt
            for ail in inv.invoice_line:
                concepto = ail.concept_id and ail.concept_id.name != 'NO APLICA RETENCION' or False
                if concepto and partner_exento: #Si tiene un concepto y el partner es exento de retener ISLR
                    raise osv.except_osv(_('Error!'),_("El proveedor es exento de aplicar retencion. Revisar las lineas de la factura y cambiar el concepto a NO APLICA RETENCION."))
                elif (not ail.concept_id) and (inv.type == 'in_invoice' or  inv.type == 'in_refund'): #Si no tiene un concepto y la factura es de compras o es una nota de credito
                    raise osv.except_osv(_('Error!'),_("Debe indicar el concepto de retencion de ISLR. En caso de no retenerle, indicar NO APLICA RETENCION."))
        return True
    
    def action_date_assign(self, cr, uid, ids, *args):
        #Se hereda la función action_date_assign para llamar funcion de validacion
        self.validar_account_invoice_line_islr_concept(cr, uid, ids)
        return super(account_invoice, self).action_date_assign(cr, uid, ids, args)

account_invoice()
