# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler
from datetime import datetime, timedelta
import datetime as dt


class despacho_report(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(despacho_report, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
            'get_qtytotal':self._get_qtytotal,
            'get_final_date':self.get_final_date,
            'get_weight':self._get_weight,
            'get_direccion':self.get_direccion,
            'get_weight_total':self._get_weight_total,
            'get_data' :self._get_data,
            'get_suma' :self._get_suma,
        })
    def _get_qtytotal(self,move_lines):
        total = 0.0
        uom = move_lines[0].product_uom.name
        for move in move_lines:
            total+=move.product_qty
        return {'quantity':total,'uom':uom}
    
    def get_final_date(self):
        datetime.now().strftime('%d-%m-%Y')
        return datetime.now().strftime('%d-%m-%Y')
        
        
    
    def _get_weight_total(self, move_lines):
        weight = 0.0
        for move in move_lines:
            weight += (move.product_qty * move.product_id.product_tmpl_id.weight)
        return weight
    
    
    def _get_weight(self, Qty, Weight):
        weight = 0.0
        weight += (Qty * Weight)
        return weight
        
    def get_direccion(self,form):
        obj_addr = self.pool.get('res.partner.address')
        pol_id =obj_addr.read(self.cr, self.uid, form['address'], ['street'])
        street=pol_id["street"]
        return street
        
    def _get_data(self,form):
        d1=form['date_from']
        d2=form['date_to']
        d3=form['parent_id']
        d4=form['address']
        data=[]
        
        sql= """SELECT  rpa.name, rpa.street, '[' || pp.default_code || '] ' || pp.name_template as nombre , sm.price_unit, puom.name, sum(sm.product_qty),
            pt.weight*sum(sm.product_qty) as peso_bruto, pt.weight_net*sum(sm.product_qty) as peso_neto
             FROM stock_picking sp 
            inner join stock_move sm on sm.picking_id = sp.id
            inner join res_partner_address rpa on rpa.id = sp.address_id
            inner join product_product pp on pp.id = sm.product_id
            inner join product_template pt on pt.id = pp.product_tmpl_id
            inner join product_uom puom on puom.id = sm.product_uom
            where sp.type ='out' and sm.location_dest_id = 128 and sp.state = 'done'
            and pt.categ_id  IN (
            select distinct slh.id as child_id from product_category slp
              left outer join product_category slh on  slh.parent_left between slp.parent_left and slp.parent_right
              """
        if  d4:     
            par=""" where slp.id = %d
            )  and sm.date between '%s' and '%s' and sp.address_id = %d
            group by rpa.street, pt.categ_id,rpa.name, pp.default_code, pp.name_template , 
            sm.price_unit, puom.name, pt.weight, pt.weight_net
            order by pt.categ_id, rpa.name,  pp.name_template"""%(d3,d1,d2,d4)
        else: 
            par=""" where slp.id = %d
            )  and sm.date between '%s' and '%s' group by rpa.street, pt.categ_id,rpa.name, pp.default_code, pp.name_template , 
            sm.price_unit, puom.name, pt.weight, pt.weight_net
            order by pt.categ_id, rpa.name,  pp.name_template"""%(d3,d1,d2)
        
        self.cr.execute(sql+par)

        data = self.cr.dictfetchall()
        return data


    def _get_suma(self,form):
        d1=form['date_from']
        d2=form['date_to']
        d3=form['parent_id']
        d4=form['address']
        data=[]
        
        self.cr.execute(
         """ SELECT   sum(sm.price_unit) as total_bs, sum(sm.product_qty) as total_cant, sum(pt.weight*sm.product_qty) as peso,sum(pt.weight_net*sm.product_qty) as peso_n
             FROM stock_picking sp 
            inner join stock_move sm on sm.picking_id = sp.id
            inner join res_partner_address rpa on rpa.id = sp.address_id
            inner join product_product pp on pp.id = sm.product_id
            inner join product_template pt on pt.id = pp.product_tmpl_id
            inner join product_uom puom on puom.id = sm.product_uom
            where sp.type ='out' and sm.location_dest_id = 128 and sp.state = 'done'
            and pt.categ_id  IN (
            select distinct slh.id as child_id from product_category slp
              left outer join product_category slh on  slh.parent_left between slp.parent_left and slp.parent_right
               where slp.id = %d
            )  and sm.date between '%s' and '%s' and sp.address_id = %d"""%(d3,d1,d2,d4))

        data = self.cr.dictfetchall()
        return data[0]


report_sxw.report_sxw('report.stock.picking.despacho.red','stock.picking','diana_out_picking_report/report/despacho_red.rml',parser=despacho_report)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
