# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler
from datetime import datetime, timedelta
import datetime as dt

class list_report(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(list_report, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
            'get_qtytotal':self._get_qtytotal,
            'get_final_date':self.get_final_date,
            'get_weight':self._get_weight,
            'get_weight_total':self._get_weight_total,
        })
    def _get_qtytotal(self,move_lines):
        total = 0.0
        uom = move_lines[0].product_uom.name
        for move in move_lines:
            total+=move.product_qty
        return {'quantity':total,'uom':uom}
    
    def get_final_date(self):
        datetime.now().strftime('%d-%m-%Y %H:%M')
        return datetime.now().strftime('%d-%m-%Y %H:%M')
        
        
    
    def _get_weight_total(self, move_lines):
        weight = 0.0
        for move in move_lines:
            weight += (move.product_qty * move.product_id.product_tmpl_id.weight)
        return weight
    
    
    def _get_weight(self, Qty, Weight):
        weight = 0.0
        weight += (Qty * Weight)
        return weight
    
report_sxw.report_sxw('report.stock.picking.list.carga','stock.picking','diana_out_picking_report/report/lista.rml',parser=list_report)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
