# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv

class presupuesto_wizard_check(osv.osv_memory):
    """
    Wizard para chequear varias imputaciones a la vez
    """
    _name = "presupuesto.wizard.check"
    _description = "Presupuesto Chequear Imputaciones"
    
    
    def chequear_imputaciones(self, cr, uid, ids, context=None):
        """
        Funcion para chequear todas imputaciones seleccionadas
        """
        pil_obj = self.pool.get('presupuesto.imputacion.linea')
        imp_ids = context.get('active_ids', [])
        pil_obj.write(cr, uid, imp_ids, {'checkear': 'check_ok'}, context=context)
        
        return {
            'type': 'ir.actions.act_window_close'
        }

presupuesto_wizard_check()
