#!/usr/bin/python
# -*- encoding: utf-8 -*-
###########################################################################
#    Copyright (C) Industrias Diana, C.A. (www.industriasdiana.gob.ve)
#    All Rights Reserved
###############Credits######################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################
from osv import osv
from osv import fields
from tools.translate import _
import calendar
import string

class wizard_meses_accion_especifica(osv.osv_memory):
    _name = 'wizard.meses.accion.especifica'
    
    _columns = {
        'confirm': fields.boolean('¿En realidad desea realizar esta operacion?'),
    }
    
    def button_confirm(self, cr, uid, ids, context=None):
        pe_obj = self.pool.get('presupuesto.ejecutado')
        per_obj = self.pool.get('periodo.presupuestario')
        ej_obj = self.pool.get('ejercicio.presupuestario')
        
        ej_act = ej_obj.find(cr, uid)
        ej_brw = ej_obj.browse(cr, uid, [ej_act])[0]
        
        for id in context['active_ids']:
            for month in ej_brw.period_ids:
                sids = pe_obj.search(cr, uid, [('accion_especifica_id','=',id),('period_id','=',month.id)])
                if sids:
                    continue
                else:
                    ejecutado_id = pe_obj.create(cr, uid,{
                    'name': string.upper(str(calendar.month_name[int(month.date_start[5:7])])),
                    'period_id': month.id,
                    'accion_especifica_id': id,
                    })
        
        return {'type':'ir.actions.act_window_close'}
        
wizard_meses_accion_especifica()
