#!/usr/bin/python
# -*- encoding: utf-8 -*-
###########################################################################
#    Copyright (C) Industrias Diana, C.A. (www.industriasdiana.gob.ve)
#    All Rights Reserved
###############Credits######################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################

from osv import osv
from osv import fields
from tools.translate import _
import time

#~ class hr_concept(osv.osv):
    #~ 
    #~ _name = 'hr.concept'
    #~ _inherit = 'hr.concept'
    #~ _description = 'Payroll Concepts'
#~ 
    #~ _columns = {
        #~ 'partida_presupuesto': fields.many2one('clasificador.presupuestario','Partida Presupuestaria'),
        #~ 'imputa': fields.boolean('Se imputa?', help="Marcar para imputar presupuestariamente este concepto"),
    #~ }
    #~ 
#~ hr_concept()

class hr_account(osv.osv):
    
    _name = 'hr.account'
    _inherit = 'hr.account'

    _columns = {
        'partida_presupuesto': fields.many2one('clasificador.presupuestario','Partida Presupuestaria'),
    }
    
hr_account()

class hr_employee(osv.osv):
    _inherit = "hr.employee"
    
    _columns = {
        'accion_especifica_id': fields.many2one('accion.especifica', 'Accion Especifica'),
    }
    
hr_employee()

class hr_process(osv.osv):
    _name = 'hr.process'
    _inherit = 'hr.process'
    
    _columns = {
        'imputacion_nomina_ids': fields.many2many('presupuesto.imputacion.linea', 'presupuesto_imputacion_nomina_ids', 'process_id', 'imputacion_id', 'Pagos de Nomina'),
    }
    
    def imputacion_nomina(self, cr, uid, process_brw, dict_asiento, context=None):
        """
        proccess_brw: browser unico del proceso de nomina que se esta ejecutando.
        dict_asiento: diccionario con las imputaciones que se van a realizar.
        La llave de este diccionario es una tupla conformado por varias browse,
        donde la posición:
        0 browse accion.especifica,
        1 browse hr.concept,
        2 browse clasificador.presupuestario,
        """
        #~ print "PREOCESO", process_brw
        #~ print "Diccionario de Asiento", dict_asiento
        imp_obj = self.pool.get('presupuesto.imputacion.linea')
        period_obj = self.pool.get('periodo.presupuestario')
        process_id = process_brw.id
        fecha = time.strftime('%Y-%m-%d')
        for tupla in dict_asiento:
            partida_id = tupla[2] and tupla[2].id or False
            payment = dict_asiento[tupla]
            periodo_id = period_obj.find(cr, uid, fecha, context=context)[0]
            accion_id = tupla[0] and tupla[0].id or False
            
            if partida_id:
                partida = tupla[2] and tupla[2].code or ''
                name = tupla[2] and tupla[2].name or ''
                partida += ' '+name
            else:
                partida = None
            
            imp_dict = {
                'ref': "Nomina: " + process_brw.name + " / " + tupla[1].name,
                'partida': partida,
                'partida_id': partida_id,
                'model': 'hr.process',
                'res_id': process_id,
                'fecha_imp': fecha,
                'amount': payment,
                'periodo': periodo_id,
                'accion_especifica_id': accion_id,
                'status': 'comprometido',
                'state': 'activo',
                'type': 'egreso',
                'type_create':'automatica',
            }
            imp_id = imp_obj.create(cr, uid, imp_dict)
            imp_obj.write(cr, uid, imp_id, {'enlace_id': imp_id})
            #~ Agrego la imputacion de comprometido de nomina al campo many2many de hr.process
            self.write(cr, uid, process_id, {'imputacion_nomina_ids': [(4, imp_id)]})
            
            imp_dict.update({'status': 'causado_gasto', 'enlace_id': imp_id})
            imp_id = imp_obj.create(cr, uid, imp_dict)
            #~ Agrego la imputacion de causado de nomina al campo many2many de hr.process
            self.write(cr, uid, process_id, {'imputacion_nomina_ids': [(4, imp_id)]})
            
            imp_dict.update({'status': 'pagado', 'enlace_id': imp_id})
            imp_id = imp_obj.create(cr, uid, imp_dict)
            #~ Agrego la imputacion de pagado de nomina al campo many2many de hr.process
            self.write(cr, uid, process_id, {'imputacion_nomina_ids': [(4, imp_id)]})
            
        return True
    
    def crear_asientos(self, cr, uid, process_brw, context=None):
        dict_asiento = super(hr_process, self).crear_asientos(cr, uid, process_brw, context=context)
        if dict_asiento:
            #~ print "DICCIONARIO desde NOMINA",dict_asiento
            acc_dict = self.crear_dict_imputacion(cr, uid, process_brw, dict_asiento, context=context)
            self.imputacion_nomina(cr, uid, process_brw, acc_dict, context=context)
        return dict_asiento
    
    def eliminar_imputacion_nomina(self, cr, uid, ids, context=None):
        pil_obj = self.pool.get('presupuesto.imputacion.linea')
        process_brw = self.browse(cr, uid, ids)
        
        for process in process_brw:
            pil_ids = pil_obj.search(cr, uid, [('model','=','hr.process'),('res_id','=', process.id)])
            pil_obj.unlink(cr, uid, pil_ids)
        
        return True
    
    def devolver_proceso(self, cr, uid, ids, context=None):
        result = super(hr_process, self).devolver_proceso(cr, uid, ids, context=context)
        if result:
            self.eliminar_imputacion_nomina(cr, uid, ids, context=context)
            
        return result
        
    def crear_dict_imputacion(self, cr, uid, process_brw, dict_asiento, context=None): 
        """
        proccess_brw: browser unico del proceso de nomina que se esta ejecutando.
        dict_asiento: diccionario con los pagos que se usaran para las imputaciones.
        La llave de este diccionario es una tupla conformado por varias browse,
        donde la posición:
        0 browse hr.concept,
        1 browse account.analytic.account,
        2 browse hr.payroll,
        3 browse account.account,
        4 string indica si es una deducción ('deduction') o un pago ('allocation')
        5 browse res.partner
        """
        total_dict = {}
        ht_acc_obj = self.pool.get('hr.account')
        
        
        for payslip_brw in process_brw.hr_payslip_ids:

            accion_esp = payslip_brw.employee_id.accion_especifica_id
            department = payslip_brw.employee_id.department_id
            payroll = payslip_brw.employee_id.hr_payroll_id
            
            for payslip_line_brw in payslip_brw.line_ids:
    
                concept = payslip_line_brw.salary_rule_id.concept_id if payslip_line_brw.salary_rule_id else payslip_line_brw.attribute_id.concept_id
                account_id = ht_acc_obj.search(cr, uid, [('concept_id','=',concept.id),
                                    ('analytic_account_id','=',department.departament_analytic_account_id.id),
                                    ('payroll_id','=',payroll.id)])
                if not account_id:
                    raise osv.except_osv(_('Error!'), _('No existe una configuración contable para el concepto\
                        %s, cuenta analítica %s y nómina %s. Para verificar ir a\
                        Talento Humano -> Configuración -> Contabilidad nómina.')
                        % (concept.name, department.departament_analytic_account_id.complete_name, payroll.name))
                
                account = ht_acc_obj.browse(cr, uid, account_id)
                
                if isinstance(account, list):
                    account = account[0]
                
                partida = account.partida_presupuesto or False
                    
                if partida:
                    if (accion_esp, concept, partida) not in total_dict:
                        total_dict[accion_esp, concept, partida] = payslip_line_brw.total
                    else:
                        total_dict[accion_esp, concept, partida] = \
                        total_dict[accion_esp, concept, partida] + payslip_line_brw.total
                
            #~ for key in total_dict.keys():
                #~ accion_esp, concept, partida = key
                #~ monto = total_dict[key]
                
        return total_dict


hr_process()

class account_voucher(osv.osv):
    _inherit = "account.voucher"
    
    
    def _accion_imputar(self, cr, uid, ids, context=None):
       """ Se hace una validacion para verificar si el
       account_voucher es generado por nomina, si es asi
       el mismo no debe ser imputado"""
       
       av_brw = self.browse(cr, uid, ids, context=context)
       #~ Se valida si hr_process_id posee valor
       if av_brw[0].hr_process_id:
           return True
       else:
           super(account_voucher,self)._accion_imputar(cr,uid,ids,context=context)
       return True
   
account_voucher()
