#!/usr/bin/python
# -*- encoding: utf-8 -*-
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
################################################################################


from osv import osv, fields
import time
from tools import config
from tools.translate import _
import decimal_precision as dp

class account_wh_muni_wizard(osv.osv_memory):

    _name = "account.wh.muni.wizard"
    _columns = {
        'partner_id': fields.many2one('res.partner', 'Partner', required=True, help="Withholding customer/supplier"),
        'invoice_id': fields.many2many('account.invoice', 'account_wh_muni_wizard_rel', 'invoice_id', 'wh_muni_line_id', required=True, ondelete='set null', help="Withholding invoice"),
        'percent_wh':fields.float('Wh Percent', required=True, digits_compute= dp.get_precision('Withhold'), help="Percent withheld"),
    }
    _defaults = {

    }
    _sql_constraints = [

    ] 
    
    def selected_invoices(self, cr, uid, ids, context=None):
        if context is None: context = {}    
        res = {}
        wh_obj = self.pool.get('account.wh.muni.line')
        inv_obj = self.pool.get('account.invoice')
        wz_brw = self.browse(cr, uid, ids, context=context)
        for reg in wz_brw:
            if reg.invoice_id:
                for inv in reg.invoice_id:
                    line_wh = {  
                                'name': 'Retencion 1x1000',
                                'wh_id': context['active_ids'][0],
                                'invoice_id': inv.id,
                                'base_amount': inv.amount_untaxed,
                                'wh_muni_rate': reg.percent_wh,
                                'wh_amount': inv.amount_untaxed * reg.percent_wh / 100,
                                'move_id': False,
                                'reference': inv.reference or '',
                                
                            }
                    wh_obj.create(cr, uid, line_wh, context=context)
        return { 
            'view_type': 'form',
            'view_mode':'form',
            'res_model': 'account.wh.muni',
            #~ 'views': [(resource_id,'form')], #Comentar en caso de que no funcione
            'type': 'ir.actions.act_window',
            'target': 'edit',
            'context': context,
            'res_id': context['active_ids'][0],
            'ref': 'l10n_ve_withholding_muni.view_wh_muni_form',
            }
        
    def cancel(self, cr, uid, ids, context=None):
        return { 
            'view_type': 'form',
            'view_mode':'form',
            'res_model': 'account.wh.muni',
            #~ 'views': [(resource_id,'form')], #Comentar en caso de que no funcione
            'type': 'ir.actions.act_window',
            'target': 'edit',
            'context': context,
            'res_id': context['active_ids'][0],
            'ref': 'l10n_ve_withholding_muni.view_wh_muni_form',
            }
        
account_wh_muni_wizard()
