#!/usr/bin/env python
# coding: utf-8
"""
Script de actualización de la información fiscal de los partners
contra la base de datos del SENIAT

"""
import xmlrpclib
import csv
import psycopg2 as dbapi2
import sys
from progress_bar import ProgressBar

########################################################################
# UPDATE FISCAL INFORMATION
########################################################################        
username = 'admin' #the user
pwd = 'admin' #the password of the user
dbname = 'sisb' #the database
HOST='localhost' #IP o Nombre del host
PORT=8069 #Puerto del Servidor
URL='http://%s:%d/xmlrpc/common'%(HOST,PORT)

# Get the uid
sock_common = xmlrpclib.ServerProxy (URL)
uid = sock_common.login(dbname, username, pwd)

#replace localhost with the address of the server
object_proxy = xmlrpclib.ServerProxy('http://%s:%d/xmlrpc/object'%(HOST,PORT))

print "Obteniendo la lista de partners a actualizar..."
partner_ids = object_proxy.execute(dbname, uid, pwd, 'res.partner', \
 'search',[('seniat_updated', '=', False)])
	 
count = 0
total = len(partner_ids) 
prog = ProgressBar(count, total, 50, mode='fixed', char='#')

print "Iniciando actualización..."
while count <= total:
	# Actualiza el partner contra el SENIAT	
	try:
		object_proxy.execute(dbname, uid, pwd, 'res.partner', \
		 'update_rif', [partner_ids[count]])
	except Exception, e:
		pass
	
	count += 1
	prog.increment_amount()
	print prog, '\r',
	sys.stdout.flush()
print

partner_ids = object_proxy.execute(dbname, uid, pwd, 'res.partner', \
 'search',[('seniat_updated', '=', False)])
object_proxy.execute(dbname, uid, pwd, 'res.partner', 'write', \
 partner_ids, {'active' : 0})
print "Se desactivaron %s partners activos cuya información fiscal era incorrecta.." % len(partner_ids)
