#!/usr/bin/python
# -*- coding: utf-8 -*-
############################################################################################
#    SISB, Sistema Integral Simón Bolívar
#    Copyright (C) 2011-2013 Industrias Diana, C.A. (<http://www.industriasdiana.gob.ve>).
#    All Rights Reserved
###############Credits######################################################################
#    Developed by: Industrias Diana, C.A.
############################################################################################

import time
from lxml import etree
import netsvc
from osv import osv, fields
import decimal_precision as dp
from tools.translate import _

class sisb_compensaciones(osv.osv):
    _inherit = "sisb.compensaciones"

    """ Extension de la clase de compensaciones
    para el registro de imputaciones, se herada la
    funcion crear_asientos """
    
    
    def crear_asientos(self, cr, uid, doc, context=None):
        if context is None:
            context = {}
        ai_obj = self.pool.get("account.invoice") 
        """
        Se calcula el pendiente de cada factura que se le este haciendo un pago,
        antes de que se realice el pago, esto para evitar el cambie en el pendiente.
        El pendiente se envia por el context.
        """
        residuales = {}
        for inv in doc:
            for line in inv.purchase_invoice_ids: 
                residuales[str(line.id)] = line.residual
            for line in inv.sale_invoice_ids:
                residuales[str(line.id)] = line.residual

        result, payments = super(sisb_compensaciones,\
                self).crear_asientos(cr, uid, doc, context)

        if result and payments:
            for inv in payments:
                res = ai_obj.dist_payment(cr, uid, 'sisb.compensaciones', doc[0].id, inv['id'], \
                        inv['monto'], residuales[str(inv['id'])], \
                        context=None)            
        else:
            raise osv.except_osv(_('Integrity Error'),('Ha Ocurrido un'+\
                ' error al intentar hacer las imputaciones'))
        return True

sisb_compensaciones()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
