# -*- coding: utf-8 -*-
from osv import osv, fields
import netsvc
import pooler
from tools.translate import _
active_id = {}

class account_voucher(osv.osv):

    _inherit='account.voucher'
    _columns={
        'multi_partner': fields.boolean('Several Supplier or Customer ?',
          required=False,
          help="Check this box if there are twice or more supplier or \
               customer for this voucher"),
    }
    
    def onchange_boolean_multi(self, cr, uid, ids, multi_partner, context=None):

        if ids:
            self.write(cr,uid,ids[0],{'multi_partner': multi_partner})
        
        default = {}
        default.setdefault('value',{})

        return default
        
    #***
    def onchange_partner_id(self, cr, uid, ids, partner_id, journal_id=None, price=None, currency_id=None, ttype=None, date=None, context=None):
        if ids:
            self.write(cr,uid,ids[0],{'partner_id':partner_id})
        
        if not ttype == None:
            default = super(account_voucher, self).onchange_partner_id(cr, uid, ids, partner_id, journal_id, price, currency_id, ttype, date, context)

        else:
            default = {}
            default.setdefault('value',{})
        
        
        return default

account_voucher()

class account_voucher_line(osv.osv):

    _inherit='account.voucher.line'
    
    def default_get(self, cr, uid, fields, context=None):
        multi = False
        if context.get('active_id'):
            try:
                multi = self.pool.get('account.voucher').browse(cr,uid,context.get('active_id')).multi_partner
            except Exception, e:
                multi = False

        if not multi:
            context.update({'mono': True})

        """ Get default values
        @param fields: List of fields for default value
        """
        if context is None:
            context = {}
        
        val = 0
        res = super(account_voucher_line, self).default_get(cr, uid, fields, context=context)
        if context.get('no_store_function',False):
            if active_id.get('activo',False):
                context.update({'active_id':active_id['activo']})
                res = self._default_get_other( cr, uid, res, context=context)
        else:
            if context.get('active_id'):
                active_id.update({'activo':context['active_id']})
                res = self._default_get_other( cr, uid, res, context=context)
                    
            else:
                res = self._default_get_other( cr, uid, res, context=context)

        res.update({'journal_id':context.get('journal_id')})

        return res

    def onchange_partner_id(self, cr, uid, ids, partner_id, journal_id, price, currency_id, ttype, invoice_id, context=None):
        if not journal_id:
            journal_id = context.get('journal_id')
        return super(account_voucher_line, self).onchange_partner_id(cr, uid, ids, partner_id, journal_id, price, currency_id, ttype, invoice_id, context=None)

account_voucher_line()
