#!/usr/bin/python	
# -*- encoding: utf-8 -*-	
###############Credits#########################################################	
#    Finance by: Industrias Diana, C.A. http://www.industriasdiana.gob.ve	
###############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###############################################################################

from osv import osv
from osv import fields
import sys
from tools.translate import _
import time


class report_albaranes(osv.osv_memory):
    
    _name = "report.albaranes"
    _description = "Reporte Albaranes"

    _columns = {
	'partner_id': fields.many2one('res.partner','Empresa'),	
	'product_id': fields.many2one('product.product','Producto'),
	'category_id': fields.many2one('product.category','Categoría de Producto'),
	'location_id': fields.many2one('stock.location','Origen'),
	'location_dest_id': fields.many2one('stock.location','Destino'),
	'date_from': fields.date("Fecha Inicio", required=True),
        'date_to': fields.date("Fecha Fin", required=True),
	'type': fields.selection([('in','Entradas'), ('out','Salidas'), ('internal','Internos')], 'Tipo'),
	'state': fields.selection([('draft','Borrador'), ('done','Realizado'), ('cancel','Cancelado')], 'Estado'),
        }

    _defaults = {
        'date_from': lambda *a: time.strftime('%Y-%m-%d'),
        'date_to': lambda *a: time.strftime('%Y-%m-%d'),
 
        }
    
	
    def report_albaranes(self, cr, uid, ids, data, context=None):
	if context is None:
            context = {}
        data['form'] = self.read(cr, uid, ids,['partner_id','product_id','category_id','location_id','location_dest_id','date_from','date_to','type','state'])[0]
	if not data['form']['product_id'] and not data['form']['category_id']:
	    raise osv.except_osv(_('mensaje_usuario'),_('Seleccione al menos un producto o una categoría'))
	if data['form']['product_id'] and data['form']['category_id']:
	    raise osv.except_osv(_('mensaje_usuario'),_('Seleccione sólo un producto o una categoría'))
	return {'type': 'ir.actions.report.xml', 'report_name': 'report.albaranes', 'datas': data}

	    
report_albaranes()
