#!/usr/bin/python	
# -*- encoding: utf-8 -*-	
###############Credits#########################################################	
#    Finance by: Industrias Diana, C.A. http://www.industriasdiana.gob.ve	
###############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###############################################################################

from report import report_sxw
import time
from datetime import datetime

class report_bank_reconciliation(report_sxw.rml_parse):
    
    _name = "report.bank.reconciliation"
       
    def __init__(self, cr, uid, name, context):
        super(report_bank_reconciliation, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
            'get_line': self.get_line,
	    'get_transitory_pays': self.get_transitory_pays,
	    'get_total': self.get_total,
	    'get_date': self.get_date,
	    'traductor': self.traductor,
        })

    def get_line(self, obj):
	obj_cta = self.pool.get('res.partner.bank').browse(self.cr,self.uid,obj['acc_number'],context=None)
	return obj_cta
    
    
    def get_transitory_pays(self, obj):
	pay_support = self.pool.get('voucher.pay.support')
	#~ pay_support_ids = pay_support.search(self.cr, self.uid, ['|',('state','=','open'),('state','=','draft'),('accounting_bank_id','=',obj['acc_number'])])
	pay_support_ids = pay_support.search(self.cr, self.uid, [('state','=','open'),('accounting_bank_id','=',obj['acc_number'])])
	pay_support_brow = pay_support.browse(self.cr, self.uid, pay_support_ids, context=None)
	return pay_support_brow
	
    def get_total(self, obj):
	pay_support_brow = self.get_transitory_pays(obj)
	mont = 0
	for pay in pay_support_brow:
	    mont += pay.amount
	return mont

    def get_date(self):
        date = time.strftime('%d/%m/%Y')
        return date

    def traductor(self, palabra):
	print "aqui1"
        if palabra == 'check':
                word='Cheque'
        if palabra == 'wire':
                word='Transferencia'
	print "aqui2"
        return word
	
report_sxw.report_sxw('report.report.bank.reconciliation',
		    'res.partner.bank',
		    'sisb_fix_report_bank_reconciliation/report/report_bank_reconciliation.rml',
		    parser=report_bank_reconciliation,
		    header="internal")
