# -*- coding: utf-8 -*-
"""
Módulo utilizado para adaptar las facturas de ventas de Industrias Diana
"""

import time
from osv import fields, osv, orm
from tools.translate import _

class account_invoice(osv.osv):
    _inherit = "account.invoice"

    def write(self, cr, uid, ids, vals, context=None):
        if isinstance(ids, (int, long)):
            ids = [ids]
            
        if context is None:
            context = {}
            
        for inv_create in self.browse(cr, uid, ids):
            if inv_create.type in ('out_invoice', 'out_refund'):
                if vals.get('date_invoice', False):
                    #si hubo modificacion
                    fecha_doc = vals.get('date_invoice') 
                else:
                    #si no hubo modif, consultar la fecha y actualizar date_document
                    fecha_doc = inv_create.date_invoice 
                vals.update({'date_document': fecha_doc})
        #TODO: Descomentar [1] si en algun momento es necesario guardar el
        # numero en la referencia de la factura 
        inv_brw = self.browse(cr, uid, ids, context)
        for inv in inv_brw:
            if inv.type in ['out_refund','out_invoice']:
                #[1] vals.update({'reference': inv.number,})
                vals.update({'name': inv.number,})
    
        res = super(account_invoice, self).write(cr, uid, ids, vals, context=context)
        
        return res
        
account_invoice()

class account_invoice_line(osv.osv):
    _inherit = 'account.invoice.line'
    
    def unlink(self, cr, uid, ids, context=None):
        ail_brw = self.browse(cr, uid, ids) 
        for line in ail_brw:
            if line.invoice_id.type in ['out_refund']:
                super(account_invoice_line, self).unlink(cr, 1, line.id, context)
            else:
                super(account_invoice_line, self).unlink(cr, uid, line.id, context)
        return True
        
account_invoice_line()
