from report import report_sxw
from numero_a_texto import Numero_a_Texto

class rep_hoja(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(rep_hoja, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'numero_en_letras': self.obt_texto,
            'agrupado_producto': self.agrupado_producto,
            'total_bultos': self.total_bultos,
            'lista_clientes': self.lista_clientes,
            'carga_x_clientes': self.carga_x_clientes,
        })
        self.context = context
        self.cr = cr
        self.uid = uid
    
    def obt_texto(self, amount):
        return  Numero_a_Texto(str(amount))
        
    def agrupado_producto(self,hoja_carga_id):
        qry = """
                select pp.id, pp.default_code, pp.name_template, 
                sum(sm.product_qty) as cantidad, 
                p_uom.name from stock_picking_hoja_carga_rel sp_hc
                inner join stock_picking sp on sp.id = sp_hc.picking_id
                inner join stock_move sm on sm.picking_id = sp.id
                inner join product_product pp on pp.id = sm.product_id
                inner join product_uom p_uom on p_uom.id = sm.product_uom
                where sp_hc.hoja_carga_id = %s
                group by pp.id, pp.default_code, pp.name_template,p_uom.name
                order by pp.default_code 
                """%(hoja_carga_id)
        self.cr.execute(qry)
        datos_agrupados = self.cr.dictfetchall()

        return datos_agrupados
    
    def total_bultos(self,hoja_carga_id):
        qry = """
                select sum(sm.product_qty) as cantidad_bulto
                from stock_picking_hoja_carga_rel sp_hc
                inner join stock_picking sp on sp.id = sp_hc.picking_id
                inner join stock_move sm on sm.picking_id = sp.id
                inner join product_product pp on pp.id = sm.product_id
                inner join product_uom p_uom on p_uom.id = sm.product_uom
                where sp_hc.hoja_carga_id = %s
                """%(hoja_carga_id)
        self.cr.execute(qry)
        total_bultos = self.cr.dictfetchone()

        return total_bultos['cantidad_bulto']
        
    def lista_clientes(self,hoja_carga_id):
        qry = """
                select distinct sp.partner_id, rp.name from stock_picking_hoja_carga_rel sp_hc
                inner join stock_picking sp on sp.id = sp_hc.picking_id
                inner join res_partner rp on rp.id = sp.partner_id
                where sp_hc.hoja_carga_id = %s
                order by rp.name
                """%(hoja_carga_id)
        self.cr.execute(qry)
        clientes = self.cr.dictfetchall()
        
        return clientes
        
    def carga_x_clientes(self,hoja_carga_id,partner_id):
        carga_x_clientes = []
        
        sp_obj = self.pool.get('stock.picking').search(self.cr, self.uid,[('hoja_carga_id','=',hoja_carga_id),('partner_id','=',partner_id)])
        
        for pick in self.pool.get('stock.picking').browse(self.cr, self.uid, sp_obj):
            for move in pick.move_lines:
                carga_x_clientes.append({
                    'sm_id': move.id,
                    'default_code': move.product_id.default_code.upper(),
                    'name_template': move.product_id.name_template[:50].upper(),
                    'name_partner': move.partner_id.name,
                    'product_qty': move.product_qty,
                    'name_product_uom': move.product_uom.name,
                    'origin': move.origin,
                    'name_picking': move.picking_id.name,
                    'number_invoice': move.number_invoice,
                    'peso_bruto': move.peso_bruto,
                })

        return carga_x_clientes
        
report_sxw.report_sxw(
    'report.sisb.hoja.de.carga',
    'hoja.de.carga',
    'sisb_hoja_de_carga/report/hoja.rml',
    parser=rep_hoja, header=False
)
