# -*- encoding: utf-8 -*-

import time
from datetime import datetime
from dateutil.relativedelta import relativedelta
import logging
from osv import osv, fields
import netsvc
import pooler
from tools.translate import _
import decimal_precision as dp
from osv.orm import browse_record, browse_null

class purchase_requisition(osv.osv):
    _inherit = "purchase.requisition"
    _logger = logging.getLogger('sisb.purchase.requisition')
    
    def do_merge(self, cr, uid, ids, context=None):
        """
            Une multiples solicitudes de compra en una.
            Se toma la primera solicitud para la fusión, el resto se cancela
        """
        if len(ids) > 1:
            req_id = ids[0]
        else:
            return False
            
        req_obj = self.browse(cr, uid, ids[0])
        
        #Actualizo y reasigno las lineas de solicitud
        req_line_obj = self.pool.get('purchase.requisition.line')
        
        req_lines_ids = req_line_obj.search(cr, uid, [('requisition_id', 'in', ids[1:])])
        
        if req_line_obj.write(cr, uid, req_lines_ids, {'requisition_id' : req_obj.id}):
            self._logger.info("purchase.requisition.lines reassigned by merge")
        else:
            return False
            
        #Actualizo y reasigno las solicitudes de presupuesto
        po_obj = self.pool.get('purchase.order')
        po_ids = po_obj.search(cr, uid, [('requisition_id', 'in', ids)])
                
        #Actualizo y reasigno las solicitudes de requisicion
        pro_obj = self.pool.get('procurement.order')
        pro_ids = pro_obj.search(cr, 1, [('requisition_id', 'in', ids)])


        """
        Para unir las notas al realizar la fusion
        """
        #~ notas_generales = ''
        #~ for line in self.browse(cr, uid, ids):
            #~ notas_generales = notas_generales + str(line.description) + '\n'
            
        pu_re_obj = self.pool.get('purchase.requisition')
        #~ pu_re_obj.write(cr, uid, req_obj.id, {'description' : notas_generales})
            
        values = {
            'requisition_id' : req_obj.id,
            'state' : 'cancel',
        }
        
        if po_obj.write(cr, uid, po_ids, values):
            self._logger.info("purchase.orders reassigned by merge")
        else: 
            return False

        if pro_obj.write(cr, uid, pro_ids, {'requisition_id' : req_obj.id}):
            self._logger.info("procurement.orders reassigned by merge")
        else: 
            return False

        if self.unlink(cr, 1, ids[1:]):
            self._logger.info("purchase.requisitions deleted by merge")
        else:
            return False
        return ids[0]

purchase_requisition()
