#-*- coding:utf-8 -*-

import netsvc
import time
from tools.translate import _
from osv import fields, osv
from datetime import *

class hr_paid_order(osv.osv):
    _name = 'hr.paid.order'
    _description = 'Ordenes de pago'

    _columns = {
        'type': fields.selection(
                [('prestamos', 'Orden de pago por prestamos'),
                ('caja_ahorro', 'Orden de pago caja de ahorro'),
                ('faov', 'Orden de pago F.A.O.V.'),], "Tipo orden de pago", required=True),
        'month_id': fields.many2one('hr.month', 'Mes', required=True),
        'payroll_id': fields.many2one('hr.payroll', 'Nomina', help='Nomina para la cual se generara la orden de pago. En caso de estar \
                                                                    vacío se generará la orden de pago para todas las nomina procesadas en el mes'),
        'concept_loan_id': fields.many2one('hr.concept.loan', "Concepto préstamo"),
        'account_voucher_id': fields.many2one('account.voucher', 'Orden de pago'),
    }

hr_paid_order()

class account_voucher(osv.osv):
    
    _inherit = "account.voucher"
    _description = "Account Voucher"
    
    _columns = {
        'hr_paid_order_ids': fields.one2many('hr.paid.order', 'account_voucher_id', 'Orden de pago de nomina'),
    }

    def unlink(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        account_voucher_brw = self.browse(cr, uid, ids)
        for a_voucher in account_voucher_brw:
            if a_voucher.hr_paid_order_ids:
                hr_paid_order = [x.id for x in a_voucher.hr_paid_order_ids]
                self.pool.get('hr.paid.order').unlink(cr, uid, hr_paid_order)
            super(account_voucher, self).unlink(cr, uid, [a_voucher.id], context)
        return True

account_voucher()


class hr_paid_order_wizard(osv.osv_memory):
    _name = 'hr.paid.order.wizard'
    _description = 'Creacion ordenes de pago'

    _columns = {
        'type': fields.selection(
                [('prestamos', 'Orden de pago para prestamos'),
                ('caja_ahorro', 'Orden de pago caja de ahorro'),
                ('faov', 'Orden de pago F.A.O.V.'),], "Tipo orden de pago", required=True),
        'month_id': fields.many2one('hr.month', 'Mes', required=True),
        'payroll_id': fields.many2one('hr.payroll', 'Nomina', help='Nomina para la cual se generara la orden de pago. En caso de estar \
                                                                    vacío se generará la orden de pago para todas las nomina procesadas en el mes'),
        'concept_loan_id': fields.many2one('hr.concept.loan', "Concepto préstamo"),
    }

    def create_paid_order(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        paid_order_wizard_brw = self.browse(cr, uid, ids)[0]
        
        if paid_order_wizard_brw.type == 'prestamos':
            if paid_order_wizard_brw.payroll_id:
                paid_order_old_id = self.pool.get('hr.paid.order').search(cr, uid, [('type','=',paid_order_wizard_brw.type),
                                                                        ('month_id','=',paid_order_wizard_brw.month_id.id),
                                                                        ('payroll_id','=',paid_order_wizard_brw.payroll_id.id),
                                                                        ('concept_loan_id','=',paid_order_wizard_brw.concept_loan_id.id),])
                if paid_order_old_id:
                    raise osv.except_osv(_('Error!'), _('Ya fue creada una orden de pago con estas característica'))
                
                paid_order_old_id = self.pool.get('hr.paid.order').search(cr, uid, [('type','=',paid_order_wizard_brw.type),
                                                                        ('month_id','=',paid_order_wizard_brw.month_id.id),
                                                                        ('payroll_id','=',False),
                                                                        ('concept_loan_id','=',paid_order_wizard_brw.concept_loan_id.id),])
                if paid_order_old_id:
                    raise osv.except_osv(_('Error!'), _('Ya fue creada una orden de pago con estas característica'))
                    
            else:
                paid_order_old_id = self.pool.get('hr.paid.order').search(cr, uid, [('type','=',paid_order_wizard_brw.type),
                                                                        ('month_id','=',paid_order_wizard_brw.month_id.id),
                                                                        ('concept_loan_id','=',paid_order_wizard_brw.concept_loan_id.id),])
                if paid_order_old_id:
                    raise osv.except_osv(_('Error!'), _('Ya fue creada una orden de pago con estas característica'))

            self.create_paid_order_loan(cr, uid, ids, paid_order_wizard_brw, context)

        elif paid_order_wizard_brw.type == 'caja_ahorro' or paid_order_wizard_brw.type == 'faov':
            if paid_order_wizard_brw.payroll_id:
                paid_order_old_id = self.pool.get('hr.paid.order').search(cr, uid, [('type','=',paid_order_wizard_brw.type),
                                                                        ('month_id','=',paid_order_wizard_brw.month_id.id),
                                                                        ('payroll_id','=',paid_order_wizard_brw.payroll_id.id),])
                if paid_order_old_id:
                    raise osv.except_osv(_('Error!'), _('Ya fue creada una orden de pago con estas característica'))
                    
                paid_order_old_id = self.pool.get('hr.paid.order').search(cr, uid, [('type','=',paid_order_wizard_brw.type),
                                                                        ('month_id','=',paid_order_wizard_brw.month_id.id),
                                                                        ('payroll_id','=',False),])
                if paid_order_old_id:
                    raise osv.except_osv(_('Error!'), _('Ya fue creada una orden de pago con estas característica'))
                    
            else:
                paid_order_old_id = self.pool.get('hr.paid.order').search(cr, uid, [('type','=',paid_order_wizard_brw.type),
                                                                        ('month_id','=',paid_order_wizard_brw.month_id.id),])
                if paid_order_old_id:
                    raise osv.except_osv(_('Error!'), _('Ya fue creada una orden de pago con estas característica'))
            self.create_paid_order_ca_faov(cr, uid, ids, paid_order_wizard_brw, context)

        return {
            'type': 'ir.actions.act_window_close',
            'active_id': ids
        }

    def create_paid_order_loan(self, cr, uid, ids, paid_order_wizard_brw, context=None):
        if context is None:
            context = {}
        account_vaucher_obj = self.pool.get('account.voucher')
        account_vaucher_line_obj = self.pool.get('account.voucher.line')
        idav = 0

        parameter_obj = self.pool.get('hr.parameters')
        #Busqueda del concepto que se definio como Diario para creacion de ordenes de pago de nomina-----------------------------
        param_paid_order_id = 0
        if paid_order_wizard_brw.payroll_id:
            param_paid_order_id = parameter_obj.search(cr, uid, [('type', '=', 'diario_orden_p'),('payroll_id', '=', paid_order_wizard_brw.payroll_id.id)])
        else:
            param_paid_order_id = parameter_obj.search(cr, uid, [('type', '=', 'diario_orden_p')])
        if not param_paid_order_id:
            param_paid_order_id = parameter_obj.search(cr, uid, [('type', '=', 'diario_orden_p'),('payroll_id', '=', None)])
        if not param_paid_order_id:
            raise osv.except_osv(_('ERROR!'), _('No hay un parametro definido para el diario de ordenes de pago. Ir a \
                                                la pestaña Configuracion -> Configuraciones de nomina -> Parametros de nomina y \
                                                registrar un parametro de tipo Diario para ordenes de pago'))
        journal_brw = parameter_obj.browse(cr, uid, param_paid_order_id)[0].journal_id
        
        period_brw = paid_order_wizard_brw.month_id.hr_period_ids
        if paid_order_wizard_brw.payroll_id:
            calendars_period = list(set([x.hr_payment_calendar_id for x in period_brw]))
            for cal in calendars_period:
                if paid_order_wizard_brw.payroll_id in cal.hr_payroll_ids:
                    calendar = cal
                    break
            period_brw = list(set(calendar.hr_period_ids) & set(period_brw))

        process_list = []
        for period in period_brw:
            process_ids = self.pool.get('hr.process').search(cr, uid, [('hr_period_ids','=', period.id),('state','=', 'done')])
            process_list = process_list + self.pool.get('hr.process').browse(cr, uid, process_ids)
        process_ids = [x.id for x in process_list]
        
        concept_id = paid_order_wizard_brw.concept_loan_id.concept_id
        partner_id = paid_order_wizard_brw.concept_loan_id.partner_id
        if not partner_id:
            raise osv.except_osv(_('ERROR!'), _('El concepto de préstamo no tiene el proveedor asociado para la genenarión de la Orden de Pago'))
        line_ids = self.pool.get('hr.payslip.line').search(cr, uid, [('code','=',concept_id.code),('process_id','in',process_ids)])
        if not line_ids:
            raise osv.except_osv(_('ERROR!'), _('No existen líneas de pago asociadas a la selección'))
        line_brw = self.pool.get('hr.payslip.line').browse(cr, uid, line_ids)
        total = reduce(lambda x,y: x+y, [x.total for x in line_brw])
        
        today = datetime.now()
        period_account_id = self.pool.get('account.period').search(cr, uid, [('date_start','<=',today or time.strftime('%Y-%m-%d')),
                                                                            ('date_stop','>=',today or time.strftime('%Y-%m-%d')),
                                                                            ('special', '=', False)])
        if not isinstance(period_account_id, list):
            period_account_id = [period_account_id]
        
        
        vals_av = {
            'type': 'payment',
            'name': 'Orden de pago creada por nómina para ' + str(concept_id.name) + ' / Mes ' + str(paid_order_wizard_brw.month_id.name) + ' ' + \
                    str(paid_order_wizard_brw.payroll_id.name if paid_order_wizard_brw.payroll_id else ''),
            'amount': total,
            'partner_id': partner_id.id,
            'pay': 'asiento',
            'period_id': period_account_id[0], 
            'journal_id': journal_brw.id,
            'account_id': journal_brw.default_credit_account_id.id,
        }
        idav = account_vaucher_obj.create(cr, uid, vals_av, context)
        if idav:
            vals_avl = {
                'name': str(concept_id.name) + ' / Mes ' + str(paid_order_wizard_brw.month_id.name),
                'voucher_id': idav,
                'account_id': partner_id.property_account_payable.id,
                'amount': total,
                'type': 'dr',
                'partner_id': partner_id.id,
            }
            idavl = account_vaucher_line_obj.create(cr, uid, vals_avl, context)

            vals_paid_loan = {
                'type': paid_order_wizard_brw.type,
                'month_id': paid_order_wizard_brw.month_id.id,
                'account_voucher_id': idav,
            }

            if paid_order_wizard_brw.payroll_id:
                vals_paid_loan.update({'payroll_id':paid_order_wizard_brw.payroll_id.id})
            if paid_order_wizard_brw.concept_loan_id:
                vals_paid_loan.update({'concept_loan_id':paid_order_wizard_brw.concept_loan_id.id})
            
            self.pool.get('hr.paid.order').create(cr, uid, vals_paid_loan, context)
        
        return True
        

    def create_paid_order_ca_faov(self, cr, uid, ids, paid_order_wizard_brw, context=None):
        parameter_obj = self.pool.get('hr.parameters')
        account_vaucher_obj = self.pool.get('account.voucher')
        account_vaucher_line_obj = self.pool.get('account.voucher.line')

        #Busqueda del concepto que se definio como Diario para creacion de ordenes de pago de nomina-----------------------------
        param_paid_order_id = 0
        if paid_order_wizard_brw.payroll_id:
            param_paid_order_id = parameter_obj.search(cr, uid, [('type', '=', 'diario_orden_p'),('payroll_id', '=', paid_order_wizard_brw.payroll_id.id)])
        else:
            param_paid_order_id = parameter_obj.search(cr, uid, [('type', '=', 'diario_orden_p')])
        if not param_paid_order_id:
            param_paid_order_id = parameter_obj.search(cr, uid, [('type', '=', 'diario_orden_p'),('payroll_id', '=', None)])
        if not param_paid_order_id:
            raise osv.except_osv(_('ERROR!'), _('No hay un parametro definido para el diario de ordenes de pago. Ir a \
                                                la pestaña Configuracion -> Configuraciones de nomina -> Parametros de nomina y \
                                                registrar un parametro de tipo Diario para ordenes de pago'))
        journal_brw = parameter_obj.browse(cr, uid, param_paid_order_id)[0].journal_id

        if paid_order_wizard_brw.type == 'caja_ahorro':
            #Busqueda del concepto que se definio como Proveedor y conceptos de Caja de Ahorro para creacion de ordenes de pago-----------------------------
            param_paid_order_id = parameter_obj.search(cr, uid, [('type', '=', 'partner_ca'),('payroll_id', '=', paid_order_wizard_brw.payroll_id.id)])
            if not param_paid_order_id:
                param_paid_order_id = parameter_obj.search(cr, uid, [('type', '=', 'partner_ca'),('payroll_id', '=', None)])
            if not param_paid_order_id:
                raise osv.except_osv(_('ERROR!'), _('No hay un parametro definido para el Proveedor y conceptos de Caja de Ahorro. Ir a \
                                                    la pestaña Configuracion -> Configuraciones de nomina -> Parametros de nomina y \
                                                    registrar un parametro de tipo Proveedor y conceptos de Caja de Ahorro'))
            partner_brw = parameter_obj.browse(cr, uid, param_paid_order_id)[0].partner_id
            concept_brw = parameter_obj.browse(cr, uid, param_paid_order_id)[0].concept_ca_o_pago_ids

        if paid_order_wizard_brw.type == 'faov':
            #Busqueda del concepto que se definio como Proveedor y conceptos FAOV para creacion de ordenes de pago-----------------------------
            param_paid_order_id = parameter_obj.search(cr, uid, [('type', '=', 'partner_faov'),('payroll_id', '=', paid_order_wizard_brw.payroll_id.id)])
            if not param_paid_order_id:
                param_paid_order_id = parameter_obj.search(cr, uid, [('type', '=', 'partner_faov'),('payroll_id', '=', None)])
            if not param_paid_order_id:
                raise osv.except_osv(_('ERROR!'), _('No hay un parametro definido para el Proveedor y conceptos FAOV. Ir a \
                                                    la pestaña Configuracion -> Configuraciones de nomina -> Parametros de nomina y \
                                                    registrar un parametro de tipo Proveedor y conceptos FAOV'))
            partner_brw = parameter_obj.browse(cr, uid, param_paid_order_id)[0].partner_id
            concept_brw = parameter_obj.browse(cr, uid, param_paid_order_id)[0].concept_faov_o_pago_ids

        #Obtener procesos
        period_brw = paid_order_wizard_brw.month_id.hr_period_ids
        if paid_order_wizard_brw.payroll_id:
            calendars_period = list(set([x.hr_payment_calendar_id for x in period_brw]))
            for cal in calendars_period:
                if paid_order_wizard_brw.payroll_id in cal.hr_payroll_ids:
                    calendar = cal
                    break
            period_brw = list(set(calendar.hr_period_ids) & set(period_brw))
        
        process_list = []
        for period in period_brw:
            process_ids = self.pool.get('hr.process').search(cr, uid, [('hr_period_ids','=', period.id),('state','=', 'done')])
            process_list = process_list + self.pool.get('hr.process').browse(cr, uid, process_ids)
        process_ids = [x.id for x in process_list]

        today = datetime.now()
        period_account_id = self.pool.get('account.period').search(cr, uid, [('date_start','<=',today or time.strftime('%Y-%m-%d')),
                                                                            ('date_stop','>=',today or time.strftime('%Y-%m-%d')),
                                                                            ('special', '=', False)])
        if not isinstance(period_account_id, list):
            period_account_id = [period_account_id]
            
        values = {}
        for cpt in concept_brw:
            values[cpt.name] = ({'sum': 0},{})
            line_ids = self.pool.get('hr.payslip.line').search(cr, uid, [('code','=',cpt.code),('process_id','in',process_ids)])
            line_brw = self.pool.get('hr.payslip.line').browse(cr, uid, line_ids)
            for line in line_brw:
                #~ if line.slip_id.employee_id.hr_payroll_id.id == paid_order_wizard_brw.payroll_id.id or not paid_order_wizard_brw.payroll_id:
                department = line.slip_id.employee_id.department_id
                account_id = self.pool.get('hr.account').search(cr, uid, [('concept_id','=',cpt.id),
                  ('analytic_account_id','=',department.departament_analytic_account_id.id),
                  ('payroll_id','=',line.slip_id.employee_id.hr_payroll_id.id)])
                contrapartida_id = self.pool.get('hr.account').browse(cr, uid, account_id)[0].account_payroll_id
                if not values[cpt.name][1].get((contrapartida_id, line.slip_id.employee_id.hr_payroll_id.name, department.departament_analytic_account_id)):
                    t = (contrapartida_id, line.slip_id.employee_id.hr_payroll_id.name, department.departament_analytic_account_id)
                    d = {t: line.total}
                    values[cpt.name][1].update(d)
                else:
                    values[cpt.name][1][(contrapartida_id, line.slip_id.employee_id.hr_payroll_id.name, department.departament_analytic_account_id)] += line.total
                values[cpt.name][0]['sum'] += line.total
        
        idav = 0
        for cpt in values:
            total = values[cpt][0]['sum']            
            if total == 0:
                continue
                
            vals_av = {
                'type': 'payment',
                'name': 'Orden de pago creada por nómina para ' + str(cpt) + ' / Mes ' + str(paid_order_wizard_brw.month_id.name) + ' ' + \
                            str(paid_order_wizard_brw.payroll_id.name if paid_order_wizard_brw.payroll_id else ''),
                'amount': total,
                'partner_id': partner_brw.id,
                'pay': 'asiento',
                'period_id': period_account_id[0], 
                'journal_id': journal_brw.id,
                'account_id': journal_brw.default_credit_account_id.id,
            }
            idav = account_vaucher_obj.create(cr, uid, vals_av, context)
            if idav:
                for item in values[cpt][1]:    
                    total_line = values[cpt][1][item]
                    vals_avl = {
                        'name': str(item[1]) + ' / ' + str(item[2].name),
                        'voucher_id': idav,
                        'account_id': item[0].id,
                        'amount': total_line,
                        'type': 'dr',
                        'partner_id': partner_brw.id,
                    }
                    idavl = account_vaucher_line_obj.create(cr, uid, vals_avl, context)

                vals_paid_loan = {
                    'type': paid_order_wizard_brw.type,
                    'month_id': paid_order_wizard_brw.month_id.id,
                    'account_voucher_id': idav,
                }

                if paid_order_wizard_brw.payroll_id:
                    vals_paid_loan.update({'payroll_id':paid_order_wizard_brw.payroll_id.id})
                if paid_order_wizard_brw.concept_loan_id:
                    vals_paid_loan.update({'concept_loan_id':paid_order_wizard_brw.concept_loan_id.id})
                
                self.pool.get('hr.paid.order').create(cr, uid, vals_paid_loan, context)
                
        if not idav:
            raise osv.except_osv(_('ERROR!'), _('No existen líneas de pago asociadas a la selección'))
            
        return True

hr_paid_order_wizard()
