#-*- coding:utf-8 -*-
from report import report_sxw
from report.report_sxw import rml_parse
from operator import itemgetter
import time
from datetime import datetime
import random
from numero_a_texto import Numero_a_Texto
import netsvc
import time
from tools.translate import _
from osv import fields, osv
import datetime
from datetime import date
import locale


class hr_constancia_trabajo(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(hr_constancia_trabajo, self).__init__(cr, uid, name, context)
        
        self.localcontext.update({
            'gerente_th':self.gerente_th,
            'get_empresa':self.get_empresa,
            'obt_texto':self.obt_texto,
            'salary':self.salary,
            'nacionalidad':self.nacionalidad,
            'cedula':self.cedula,
            'salary_dia_me':self.salary_dia_me,
            'get_name_departament':self.get_name_departament,


        })
        self.context = context
        
        
    def get_name_departament(self, employee):
        departamento = employee.department_id.complete_name.split('/')
        val = ' / '.join([departamento[i].strip() for i in range(1,len(departamento))])

        return val
        
        
        
        
    def gerente_th(self):
        #Busqueda del concepto que se definio como Gerencte de Talento Humano
        param_gerente_id = self.pool.get('hr.parameters').search(self.cr, self.uid, [('type', '=', 'gerente_th')])
        if not param_gerente_id:
            raise osv.except_osv(_('ERROR!'), _('No hay un parametro definido para Gerente de Talento Humano. Ir a \
                            la pestana Configuracion -> Configuraciones de nomina -> Parametros de nomina y \
                            registrar un parametro de tipo Gerente de Talento Humano'))

        gerente_brw = self.pool.get('hr.parameters').browse(self.cr, self.uid, param_gerente_id)[0].gerente
        return gerente_brw
    
    
    
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
        
        
    def salary(self, employee):
        if employee.type_employee == 'obrero':
            return 'Diario'
        else:
            return 'Mensual'
            
            
    def salary_dia_me(self, employee):
        if employee.type_employee == 'obrero':
            return 'Salario'
        else:
            return 'Sueldo'
        
    def nacionalidad(self, employee):
        if employee.country_id.code == 'VE':
            return 'V-'
        else:
            return 'E-'
            
    def cedula(self, employee):
        ced = employee.identification_id
        algo = '{:,}'.format(int(ced))
        return algo.replace(',','.')
        

    def obt_texto(self, amount):
        return  Numero_a_Texto(str(amount))


report_sxw.report_sxw(
        'report.hr.constancia.trabajo',
        'hr.employee',
        'sisb_nomina/report/hr_constancia_trabajo.rml',
        parser=hr_constancia_trabajo, header=False
)
