#~ # -*- coding: utf-8 -*-
from report import report_sxw
import time
from datetime import datetime, timedelta


class hr_listado_conceptos_report(report_sxw.rml_parse):

    _name= 'hr.listado.conceptos'
    def __init__(self, cr, uid, name, context):
        
        super(hr_listado_conceptos_report, self).__init__(cr, uid, name, context)
        self.localcontext.update(
        {
            'get_empresa':self.get_empresa,
            'create_lista_concepto':self.create_lista_concepto,
            'get_mes':self.get_mes,
            'get_concepto':self.get_concepto,
            'get_total':self.get_total,
            'get_final_date':self.get_final_date,
                    })
        self.context= context
        self.ids= context.get('active_ids')

    def create_lista_concepto(self, valor, context=None):
        if context is None:
            context = {}
        res = {}
        res1 = {}
        hr_month_obj = self.pool.get('hr.month')
        hr_monthr_brw = hr_month_obj.browse(self.cr, self.uid, valor['month_id'])
        hr_payroll_obj = self.pool.get('hr.payroll')
        hr_concept_obj = self.pool.get('hr.concept')
        hr_concept_brw = hr_concept_obj.browse(self.cr, self.uid, valor['concept_id'])
        period_brw = hr_monthr_brw.hr_period_ids
        
        if valor['payroll_id']:
            hr_payroll_brw = hr_payroll_obj.browse(self.cr, self.uid, valor['payroll_id'])
            periods_payroll_brw = hr_payroll_brw.hr_payment_calendar_id.hr_period_ids
            period_brw = list(set(periods_payroll_brw) & set(period_brw))
        process_list = []
        for period in period_brw:
            process_ids = self.pool.get('hr.process').search(self.cr, self.uid, [('hr_period_ids','=', period.id),('state','=', 'done')])
            process_list = process_list + self.pool.get('hr.process').browse(self.cr, self.uid, process_ids)
        process_ids = [x.id for x in process_list]
        concept_id = hr_concept_brw
        line_ids = self.pool.get('hr.payslip.line').search(self.cr, self.uid, [('code','=',concept_id.code),('process_id','in',process_ids)])
        if not line_ids:
            raise osv.except_osv(_('ERROR!'), _('No existen líneas de pago asociadas al concepto'))
        line_brw = self.pool.get('hr.payslip.line').browse(self.cr, self.uid, line_ids)
    
        for row in line_brw:
            if not (row.employee_id.cod_number, row.employee_id.identification_id, row.employee_id.name) in res:
                res[row.employee_id.cod_number, row.employee_id.identification_id, row.employee_id.name] = row.total
            else:
                res[row.employee_id.cod_number, row.employee_id.identification_id, row.employee_id.name] = \
                    res[row.employee_id.cod_number, row.employee_id.identification_id, row.employee_id.name] + row.total    
        
        lista =[]
        l1 =[]
        for val in res.keys():
            l1 = [val[0], val[1], val[2], res[val]]
            lista.append(l1)
        return lista
        
    def get_total(self, valor, context=None):
        if context is None:
            context = {}
        res = {}
        hr_month_obj = self.pool.get('hr.month')
        hr_monthr_brw = hr_month_obj.browse(self.cr, self.uid, valor['month_id'])
        hr_payroll_obj = self.pool.get('hr.payroll')
        hr_concept_obj = self.pool.get('hr.concept')
        hr_concept_brw = hr_concept_obj.browse(self.cr, self.uid, valor['concept_id'])
        period_brw = hr_monthr_brw.hr_period_ids
        if valor['payroll_id']:
            hr_payroll_brw = hr_payroll_obj.browse(self.cr, self.uid, valor['payroll_id'])
            periods_payroll_brw = hr_payroll_brw.hr_payment_calendar_id.hr_period_ids
            period_brw = list(set(periods_payroll_brw) & set(period_brw))
        process_list = []
        for period in period_brw:
            process_ids = self.pool.get('hr.process').search(self.cr, self.uid, [('hr_period_ids','=', period.id),('state','=', 'done')])
            process_list = process_list + self.pool.get('hr.process').browse(self.cr, self.uid, process_ids)
        process_ids = [x.id for x in process_list]
        concept_id = hr_concept_brw
        line_ids = self.pool.get('hr.payslip.line').search(self.cr, self.uid, [('code','=',concept_id.code),('process_id','in',process_ids)])
        line_brw = self.pool.get('hr.payslip.line').browse(self.cr, self.uid, line_ids)
        #~ total = reduce(lambda x,y: x+y, [x.total for x in line_brw])
        total = 0
        for line in line_brw:
            total = total + line.total
        return total


    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
        
   
    def get_mes(self, valor):
        obj_mes = self.pool.get('hr.month')
        res = {}
        row_brw = obj_mes.browse(self.cr, self.uid, valor['month_id'])
        if not isinstance(row_brw, list):
            row_brw = [row_brw]
        for row in row_brw:
            res = {
            'name':row.name,
            }
        return res
        
        
    def get_concepto(self, valor):
        obj_mes = self.pool.get('hr.concept')
        res = {}
        row_brw = obj_mes.browse(self.cr, self.uid, valor['concept_id'])
        if not isinstance(row_brw, list):
            row_brw = [row_brw]
        for row in row_brw:
            res = {
            'name':row.name,
            }
        return res
        
        
    def get_final_date(self):
        return datetime.now().strftime('%d-%m-%Y %H:%M')
        
  
report_sxw.report_sxw('report.hr.listado.conceptos',
                    'hr.process',
                     #~ parser= islr_sisb_report,
                     parser= hr_listado_conceptos_report,
                    #~ header= 'internal',
                    rml= 'sisb_nomina/report/hr_listado_conceptos.rml'
                    )
