from report import report_sxw
from report.report_sxw import rml_parse
from operator import itemgetter
import time
from datetime import datetime
import random
from numero_a_texto import Numero_a_Texto

class propuesta_liquidacion(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(propuesta_liquidacion, self).__init__(cr, uid, name, context)
        
        self.localcontext.update({
            'rif':self.rif,
            'lineas': self.lineas,
            'total_lineas': self.total_lineas,
            'comprobar_lineas': self.comprobar_lineas,
            'numero_en_letras': self.obt_texto,
            'gerente_th': self.gerente_th,
            'cedula': self.cedula,
        })
        self.context = context
        self.lineas = []
        self.total_lineas = 0.0
        self.comprobar_lineas = False
        
    def company(self):
        return self.pool.get('res.users').browse(self.cr, self.uid, self.uid).company_id.name

    def rif(self):
        return self.pool.get('res.users').browse(self.cr, self.uid, self.uid).company_id.partner_id.vat[2:]
        
    def lineas(self, lineas, tipo, tipo_calc):
        l = [x for x in lineas if (x.concept_id.category_id.name == tipo and x.concept_id.type_calc == tipo_calc)]
        return l
        
    def total_lineas(self, lineas, tipo, tipo_calc):
        l = [x for x in lineas if (x.concept_id.category_id.name == tipo and x.concept_id.type_calc == tipo_calc)]
        total = 0.0
        total = reduce(lambda x,y: x+y, [x.total for x in l])
        return total
        
    def comprobar_lineas(self, lineas, tipo, tipo_calc, titulo):
        l = [x for x in lineas if (x.concept_id.category_id.name == tipo and x.concept_id.type_calc == tipo_calc)]
        if l:
            return titulo
        return False
    
    def obt_texto(self, amount):
        return  Numero_a_Texto(str(amount))
        
    def gerente_th(self):
        #Busqueda del concepto que se definio como Gerencte de Talento Humano
        param_gerente_id = self.pool.get('hr.parameters').search(self.cr, self.uid, [('type', '=', 'gerente_th')])
        if not param_gerente_id:
            raise osv.except_osv(_('ERROR!'), _('No hay un parametro definido para Gerente de Talento Humano. Ir a \
                            la pestana Configuracion -> Configuraciones de nomina -> Parametros de nomina y \
                            registrar un parametro de tipo Gerente de Talento Humano'))

        gerente_brw = self.pool.get('hr.parameters').browse(self.cr, self.uid, param_gerente_id)[0].gerente
        return gerente_brw

    def cedula(self, employee):
        ced = employee.identification_id
        algo = '{:,}'.format(int(ced))
        if employee.country_id.code == 'VE':
            return 'V-' + algo.replace(',','.')
        else:
            return 'E-' + algo.replace(',','.')
        
report_sxw.report_sxw(
        'report.propuesta.liquidacion',
        'hr.linea.liquidacion',
        'sisb_nomina/report/propuesta_liquidacion.rml',
        parser=propuesta_liquidacion, header=False
)
