#-*- coding:utf-8 -*-

import netsvc
import time
from tools.translate import _
from osv import fields, osv
import calendar
from datetime import *
import datetime

class hr_make_period(osv.osv_memory):
    _name = 'hr.make.period'
    _description = 'Make Period'
    
    def _select_year(self, cr, uid, context=None):
        if context is None:
            context = {}
        lista = []
        today = date.today()
        year = today.year
        year_obj = self.pool.get('hr.year')
        last_year = year_obj.search(cr, uid, [], order='year')
        if last_year:
            year_brw = year_obj.browse(cr, uid, last_year[-1])
            year = year_brw.year
            if not year_brw.diario_mensual:
                return [(year,year),(year+1, year+1)]
            else:
                return [(year+1, year+1)]            
        return [(year, year)]
        
    _columns = {
        'year': fields.selection(_select_year, "Año", required=True),
        'type': fields.selection([('diario', 'Diario'),('mensual', 'Mensual')], "Tipo período", required=True),
    }
    
    def verify_period(self, cr, uid, ids, context=None):
        period_obj = self.pool.get('hr.period')
        today = date.today()
        
        if not period_obj.search(cr, uid, [('year', '=', today.year)]):
            return True
        
        return False

    def defuse_period(self, cr, uid, ids, context=None):
        period_obj = self.pool.get('hr.period')
        today = date.today()
        previous_period = today.year-1
        previous_period_id = period_obj.search(cr, uid, [('year', '=', previous_period)])
        if previous_period_id:
            return period_obj.write(cr, uid, previous_period_id, {'active':False})
        return False
    
    def weeks(self, month_list):
        num_weeks = 0
        for week in month_list:
            if week[calendar.THURSDAY]:
                num_weeks+=1
        return num_weeks
        
    def monday(self, month_list):
        num_monday = 0
        for week in month_list:
            if week[calendar.MONDAY]:
                num_monday+=1
        return num_monday
        
    def monday_first_fortnight(self, month_list):
        num_monday_first_fortnight = 0
        for week in month_list:
            if week[calendar.MONDAY] and week[calendar.MONDAY] <= 15:
                num_monday_first_fortnight+=1
        return num_monday_first_fortnight
        
    def monday_second_fortnight(self, month_list):
        num_monday_second_fortnight = 0
        for week in month_list:
            if week[calendar.MONDAY] and week[calendar.MONDAY] > 15:
                num_monday_second_fortnight+=1
        return num_monday_second_fortnight

    def saturday_first_fortnight(self, month_list):
        num_saturday_first_fortnight = 0
        for week in month_list:
            if week[calendar.SATURDAY] and week[calendar.SATURDAY] <= 15:
                num_saturday_first_fortnight+=1
        return num_saturday_first_fortnight
        
    def saturday_second_fortnight(self, month_list):
        num_saturday_second_fortnight = 0
        for week in month_list:
            if week[calendar.SATURDAY] and week[calendar.SATURDAY] > 15:
                num_saturday_second_fortnight+=1
        return num_saturday_second_fortnight

    def sunday_first_fortnight(self, month_list):
        num_sunday_first_fortnight = 0
        for week in month_list:
            if week[calendar.SUNDAY] and week[calendar.SUNDAY] <= 15:
                num_sunday_first_fortnight+=1
        return num_sunday_first_fortnight
        
    def sunday_second_fortnight(self, month_list):
        num_sunday_second_fortnight = 0
        for week in month_list:
            if week[calendar.SUNDAY] and week[calendar.SUNDAY] > 15:
                num_sunday_second_fortnight+=1
        return num_sunday_second_fortnight
        
    def saturday(self, month_list):
        num_saturday = 0
        for week in month_list:
            if week[calendar.SATURDAY]:
                num_saturday+=1
        return num_saturday
        
    def sunday(self, month_list):
        num_sunday = 0
        for week in month_list:
            if week[calendar.SUNDAY]:
                num_sunday+=1
        return num_sunday
        
    def week_belongs_month(self, week, num_period_month, month_list):
        week_in_month = False
        last_period_month = False
        if week[calendar.THURSDAY]:
            week_in_month = True
            
        if week_in_month: #Si el periodo esta dentro del mes verificar si es el ultimo
            if len(month_list) == month_list.index(week) + 1:
                last_period_month = True
            else:
                next_week = month_list[month_list.index(week) + 1]
                if not next_week[calendar.THURSDAY]:
                    last_period_month = True
        return week_in_month, last_period_month
        
    def date_start(self, week, num_period_month, month, year, type_period):
        if type_period == 'diario':
            if week[calendar.MONDAY]:
                #~ return str(year)+'-'+str(month)+'-'+str(week[calendar.MONDAY])
                return datetime.datetime(year, month, week[calendar.MONDAY])
            else:
                if num_period_month == 1 and month == 1: #Si es la primera semana del mes y el mes es 1 (enero) entonces se consulta diciembre del año anterior
                    month_bef = calendar.monthcalendar(year-1, 12)
                    day = month_bef[len(month_bef)-1][calendar.MONDAY]
                    #~ return str(year-1)+'-'+str(12)+'-'+str(day)
                    return datetime.datetime(year-1, 12, day)
                else:
                    month_bef = calendar.monthcalendar(year, month-1)
                    day = month_bef[len(month_bef)-1][calendar.MONDAY]
                    #~ return str(year)+'-'+str(month-1)+'-'+str(day)
                    return datetime.datetime(year, month-1, day)
        else:
            if num_period_month == 1:
                return datetime.datetime(year, month, 1)
            else:
                return datetime.datetime(year, month, 16)
        return False
        
    def date_end(self, week, num_period_month, month, year, type_period):
        if type_period == 'diario':
            if week[calendar.SUNDAY]:
                #~ return str(year)+'-'+str(month)+'-'+str(week[calendar.SUNDAY])
                return datetime.datetime(year, month, week[calendar.SUNDAY])
            else:
                month_list = calendar.monthcalendar(year, month) #Mes actual
                if num_period_month == len(month_list) and month == 12: #Si es la ultima semana del mes y el mes es 12 (diciembre) entonces se consulta enero del año prox
                    month_aft = calendar.monthcalendar(year+1, 1)
                    day = month_aft[0][calendar.SUNDAY]
                    #~ return str(year+1)+'-'+str(1)+'-'+str(day)
                    return datetime.datetime(year+1, 1, day)
                else:
                    month_aft = calendar.monthcalendar(year, month+1)
                    day = month_aft[0][calendar.SUNDAY]
                    #~ return str(year)+'-'+str(month+1)+'-'+str(day)
                    return datetime.datetime(year, month+1, day)
        else:
            if num_period_month == 1:
                return datetime.datetime(year, month, 15)
            else:
                last_week = calendar.monthcalendar(year, month)[-1]
                return datetime.datetime(year, month, max(last_week))
        return False
        
    def get_period_account(self, cr, uid, week, num_period_month, month_list, date_start, date_end):
        period_account_id = self.pool.get('account.period').search(cr, uid, [('date_start','<=',date_start or time.strftime('%Y-%m-%d')),
                                                                            ('date_stop','>=',date_start or time.strftime('%Y-%m-%d')),
                                                                            ('special', '=', False)])
        if not period_account_id:
            period_account_id = self.pool.get('account.period').search(cr, uid, [('date_start','>=',date_start or time.strftime('%Y-%m-%d')),
                                                                            ('date_start','<=',date_end or time.strftime('%Y-%m-%d')),
                                                                            ('special', '=', False)])
            if not period_account_id:
                period_account_id = self.pool.get('account.period').search(cr, uid, [('date_stop','>=',date_start or time.strftime('%Y-%m-%d')),
                                                                            ('date_stop','<=',date_end or time.strftime('%Y-%m-%d')),
                                                                            ('special', '=', False)])
                if not period_account_id:
                    raise osv.except_osv(_('ERROR!'), _('No se encuentra un período contable para el período de nómina comprendido \
                                                                    entre %s y %s')%(date_start,date_end))
        if isinstance(period_account_id, list):
            period_account_id = period_account_id[0]
            
        period_account_brw = self.pool.get('account.period').browse(cr, uid, period_account_id)

        if not (datetime.datetime.strptime(period_account_brw.date_stop,"%Y-%m-%d").day - date_start.day >= 3) \
            and (datetime.datetime.strptime(period_account_brw.date_start,"%Y-%m-%d") < date_start): 
            #No es el periodo correcto ya que esta semana pertenece al siguiente mes
            new_date_start = datetime.datetime.strptime(period_account_brw.date_stop,"%Y-%m-%d") + datetime.timedelta(days=1)
            period_account_id = self.pool.get('account.period').search(cr, uid, [('date_start','<=',new_date_start or time.strftime('%Y-%m-%d')),
                                                                                ('date_stop','>=',new_date_start or time.strftime('%Y-%m-%d')),
                                                                                ('special', '=', False)])
            if not period_account_id:
                raise osv.except_osv(_('ERROR!'), _('No se encuentra un período contable para el período de nómina comprendido \
                                                                entre %s y %s')%(date_start,date_end))
        
        if isinstance(period_account_id, list):
            period_account_id = period_account_id[0]
        
        return period_account_id

    def make_period(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
            
        year_obj = self.pool.get('hr.year')
        month_obj = self.pool.get('hr.month')
        period_obj = self.pool.get('hr.period')
        payment_calendar_obj = self.pool.get('hr.payment.calendar')
        
        result_dict_month = {}
        result_dict_week = {}
        
        make_period_brw = self.browse(cr, uid, ids)[0]
        year = make_period_brw.year
        type_period = make_period_brw.type

        num_period_year = 1
        year_id = year_obj.search(cr, uid, [('year', '=', year)])
        year_brw = year_obj.browse(cr, uid, year_id)
        if not year_id:
            year_id = year_obj.create(cr, uid, {'year':year, 'name':year})
        else:
            month_ids = [x.id for x in year_brw[0].hr_month_ids]
            period_ids = period_obj.search(cr, uid, [('hr_month_id', 'in', [x.id for x in year_brw[0].hr_month_ids])])
            period_brw = period_obj.browse(cr, uid, period_ids)
            if type_period == period_brw[0].type:
                raise osv.except_osv(_('Acción Denegada!'), _('El período %s ya fue generado para el año seleccionado')%(type_period))
            year_obj.write(cr, uid, year_id, {'diario_mensual': True})
        
        if type(year_id) == list:
            year_id = year_id[0]

        result_dict_payment_calendar = {
                'name': type_period+'-'+str(year),
                'hr_year_id': year_id,
                'type': type_period,
            }
        payment_calendar_id = payment_calendar_obj.create(cr, uid, result_dict_payment_calendar)    
        
        for month in range(1,13):
            month_list = calendar.monthcalendar(year, month)
            if not year_brw:
                key = calendar.month(year, month)
                month_mane = key[0:key.find('\n')].strip()
                result_dict_month = {
                    'name': month_mane,
                    'month_year': month,
                    'weeks': self.weeks(month_list),
                    'monday': self.monday(month_list),
                    'monday_first_fortnight': self.monday_first_fortnight(month_list),
                    'monday_second_fortnight': self.monday_second_fortnight(month_list), 
                    'saturday_first_fortnight': self.saturday_first_fortnight(month_list), 
                    'saturday_second_fortnight': self.saturday_second_fortnight(month_list), 
                    'sunday_first_fortnight': self.sunday_first_fortnight(month_list), 
                    'sunday_second_fortnight': self.sunday_second_fortnight(month_list), 
                    'saturday': self.saturday(month_list),
                    'sunday': self.sunday(month_list),
                    'hr_year_id': year_id,
                }                        
                month_id = month_obj.create(cr, uid, result_dict_month)
            
            else:
                month_id = month_ids[month-1]
            
            if type_period == 'diario':
                num_period_month = 1
                for week in month_list:
                    week_in_month, last_period_month = self.week_belongs_month(week, num_period_month, month_list)
                    
                    if week_in_month:
                        date_start = self.date_start(week, num_period_month, month, year, type_period)
                        date_end = self.date_end(week, num_period_month, month, year, type_period)
                        
                        period_account_id = self.get_period_account(cr, uid, week, num_period_month, month_list, date_start, date_end)
                        
                        if not period_account_id:
                            raise osv.except_osv(_('ERROR!'), _('No se encuentra un período contable para el período de nómina comprendido \
                                                                entre %s y %s')%(date_start,date_end)) 
                        result_dict_period = {
                            'name': 'Semanal'+' del '+str(date_start.strftime("%Y-%m-%d"))+' al '+str(date_end.strftime("%Y-%m-%d")),
                            'period_in_year': num_period_year,
                            'period_in_month': num_period_month,
                            'date_start': date_start,
                            'date_end': date_end,
                            'hr_month_id': month_id,
                            'last_period_month': last_period_month,
                            'type': type_period,
                            'hr_payment_calendar_id': payment_calendar_id,
                            'period_account_id': period_account_id,
                            
                        }
                        num_period_month += 1 
                        num_period_year += 1
                        period_id = period_obj.create(cr, uid, result_dict_period)
            
            else:
                num_period_month = 1
                for i in range(2):  
                    date_start = self.date_start(None, num_period_month, month, year, type_period)
                    date_end = self.date_end(None, num_period_month, month, year, type_period)
                    period_account_id = self.pool.get('account.period').search(cr, uid, [('date_start','<=',date_start or time.strftime('%Y-%m-%d')),
                                                                                        ('date_stop','>=',date_start or time.strftime('%Y-%m-%d')),
                                                                                        ('special', '=', False)])
                    if not period_account_id:
                        raise osv.except_osv(_('ERROR!'), _('No se encuentra un período contable para el período de nómina comprendido \
                                                            entre %s y %s')%(date_start.strftime("%Y-%m-%d"),date_end.strftime("%Y-%m-%d")))     
                                                             
                    result_dict_period = {
                        'name': 'Quincenal' +' del '+str(date_start.strftime("%Y-%m-%d"))+' al '+str(date_end.strftime("%Y-%m-%d")),
                        'period_in_year': num_period_year,
                        'period_in_month': num_period_month,
                        'date_start': date_start,
                        'date_end': date_end,
                        'hr_month_id': month_id,
                        'last_period_month': True if num_period_month == 2 else False,
                        'type': type_period,
                        'hr_payment_calendar_id': payment_calendar_id,
                        'period_account_id': period_account_id[0],

                    }
                    num_period_month += 1 
                    num_period_year += 1
                    period_id = period_obj.create(cr, uid, result_dict_period)

        #~ raise osv.except_osv(_('Acción Denegada!'), _('Momento'))      
            
        return {
            'type': 'ir.actions.act_window_close',
            'active_id': ids
        }
        
hr_make_period()
