#-*- coding:utf-8 -*-

import netsvc
import time
from tools.translate import _
from osv import fields, osv
import calendar
from datetime import date
from datetime import datetime
from datetime import timedelta

class hr_salary_increase_history(osv.osv_memory):
    
    _name = 'hr.salary.increase.history'
    _description = 'Salary Increase History'
    
    _columns = {
        'employee_id': fields.many2one('hr.employee', 'Empleado'),
        'atribute_ids': fields.many2many('hr.attribute', 'hr_attribute_increase_history_rel', 'hr_salary_increase_history_id', 
                                            'hr_attribute_id', 'Atributos', readonly=True),
    }

    def default_get(self, cr, uid, fields, context=None):
        """ To get default values for the object.
        @param self: The object pointer.
        @param cr: A database cursor
        @param uid: ID of the user currently logged in
        @param fields: List of fields for which we want default values
        @param context: A standard dictionary
        @return: A dictionary which of fields with values.
        """
        if context is None:
            context = {}
        
        record_id = context and context.get('active_id', False) or False
        res = super(hr_salary_increase_history, self).default_get(cr, uid, fields, context=context)
        employee_id = self.pool.get('hr.employee').browse(cr, uid, record_id, context=context)
                
        #Busqueda del concepto que se definio como concepto sueldo en los parametros de la nomina
        parameter_obj = self.pool.get('hr.parameters')
        param_concept_salary_id = parameter_obj.search(cr, uid, [('type', '=', 'concepto_sueldo'),('payroll_id', '=', employee_id.hr_payroll_id.id)])
        if not param_concept_salary_id:
            param_concept_salary_id = parameter_obj.search(cr, uid, [('type', '=', 'concepto_sueldo'),('payroll_id', '=', None)])
        if not param_concept_salary_id:
            raise osv.except_osv(_('ERROR!'), _('No hay un parametro definido para el concepto salario para la nomina %s. Ir a \
                                                la pestaña Configuracion -> Configuraciones de nomina -> Parametros de nomina y \
                                                registrar un parametro de tipo Concepto Salario')
                                                %(employee_id.hr_payroll_id.name))

        concept_salary_brw = parameter_obj.browse(cr, uid, param_concept_salary_id)[0].concept_wage_id
        
        attr_ids = self.pool.get('hr.attribute').search(cr, uid, [('employee_id', '=', employee_id.id),('concept_id','=',concept_salary_brw.id),
                                                    '|',('active', '=', True),('active','=',False)], 
                                                            order = 'date_start desc')
        
        if 'employee_id' in fields:
            res.update({
                'employee_id': employee_id.id,
                'atribute_ids': attr_ids,
            })
        return res
        
hr_salary_increase_history()
