# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import time
from datetime import datetime
from dateutil.relativedelta import relativedelta
from osv import fields, osv
import netsvc
import pooler
from osv.orm import browse_record, browse_null
from tools.translate import _

class purchase_configuration(osv.osv):
    _name = "purchase.configuration"
    _description = "Purchase Configuration"
    
    _columns = {
        'name': fields.char('Description', size=64, required=True),
        'flete':fields.many2one('product.product', 'Flete', required=True),
    }

purchase_configuration()


class purchase_order(osv.osv):
    
    _inherit = "purchase.order"
    
    def agregar_flete(self,cr,uid,ids,context=None):
	
	obj_purchase_conf = self.pool.get('purchase.configuration')
	try:
	    ids_conf = obj_purchase_conf.search(cr,uid,[])
	    flete = obj_purchase_conf.browse(cr,uid,ids_conf[0]).flete.id
	except Exception, e:
	    raise osv.except_osv(_('Error !'), _('Primero registre un flete en la configuración de compra'))

	prod_flete = self.pool.get('product.product').browse(cr,uid,flete)
	product_supplierinfo_obj = self.pool.get('product.supplierinfo')
	purchase_order_line_obj = self.pool.get('purchase.order.line')	
	
	prod_flete_template = self.pool.get('product.template').browse(cr,uid,flete)

	prod_supp_info = product_supplierinfo_obj.search(cr,uid,[('product_id','=',prod_flete.id)])
	prod_supp_info_brw = product_supplierinfo_obj.browse(cr,uid,prod_supp_info[0])

	lineas_existentes = purchase_order_line_obj.search(cr,uid,[('order_id','=', ids[0])])
	lineas_existentes_brw = purchase_order_line_obj.browse(cr,uid,lineas_existentes)
	
	for n in lineas_existentes_brw:
	    if n.date_planned:
		date_planned = n.date_planned
		break
		
	linea = {
                'product_uom': prod_flete.uom_po_id.id,
                'order_id': ids[0],
                'price_unit': prod_flete.price,		
                'product_qty': 1.0,
                'partner_id': prod_supp_info_brw.name.id,
                'date_planned': date_planned or '',				
		'name': prod_flete.partner_ref,
		'notes': prod_flete.partner_ref,
                'state': 'draft',
                'product_id': prod_flete.id,
		}
		
	purchase_order_line_obj.create(cr,uid, linea)
        return True

purchase_order()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
