#~ # -*- coding: utf-8 -*-
from report import report_sxw
import time
from datetime import datetime, timedelta
import datetime as dt


class compra_report(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        
        super(compra_report, self).__init__(cr, uid, name, context)
        self.localcontext.update(
        {
            'get_taxes': self.get_taxes,
            'get_name': self.get_name,
            'get_date':self.get_date,
            'get_empresa':self.get_empresa,
            'get_cantidad':self.get_cantidad,
           
                    })
        self.context= context
        

        
    def get_taxes(self,ol):
        res = {}
        for tax_id in ol.taxes_id:
            if res.get(tax_id.name, False):
                res += tax_id.amount*ol.price_subtotal
            else:
                res = tax_id.amount*ol.price_subtotal
        return res

        
    def get_name(self,ol):
        res = {}
        for tax_id in ol.taxes_id:
            if res.get(tax_id.name, False):
               res= tax_id.name
            else:
               res= tax_id.name
        return res
        
    def get_date(self,ol):
        res={}
        dateStr1 = str(ol.date_order)
        dateStr2 = str(ol.minimum_planned_date)

        d1, m1, y1 = (int(x) for x in dateStr1.split('/'))
        d2, m2, y2 = (int(x) for x in dateStr2.split('/'))
        date1 = dt.date(y1, m1, d1)
        date2 = dt.date(y2, m2, d2)
        dateDiff = date2 - date1
        x=str(dateDiff)
        number=x.split(",")
        number_1=number[0].split(" ")
        if number_1[1] == 'days':
            number_1[1] = 'dias'

        if number_1[1] == 'day':
            number_1[1] = 'dia'
        if number_1[1] == 'month':
            number_1[1] = 'mes'
        if number_1[1] == 'months':
            number_1[1] = 'meses'
        if number_1[1] == 'year':
            number_1[1] = 'año'
        if number_1[1] == 'years':
            number_1[1] = 'años'
        fecha="%s %s"%(number_1[0],number_1[1])

        return fecha

    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
        
    def get_cantidad(self, purchase_order):
        obj_addr = self.pool.get('purchase.order.line')
        pol_id =obj_addr.search(self.cr, self.uid, [('product_qty','!=','0.0'),('order_id','=',purchase_order)])
        return obj_addr.browse(self.cr, self.uid, pol_id)

report_sxw.report_sxw('report.purchase.order.compra',
                    'purchase.order',
                     parser= compra_report,
                    #~ header= 'internal',
                    rml= 'sisb_purchase_management/report/compra.rml'
                    )
