# -*- coding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler
from datetime import datetime, timedelta
import datetime as dt

class request_quotation(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(request_quotation, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
            'user': self.pool.get('res.users').browse(cr, uid, uid, context),
            'get_empresa':self.get_empresa,
            'get_cantidad':self.get_cantidad,
            'get_final_date':self.get_final_date,
        })
        
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
    
    def get_cantidad(self, purchase_order):
        obj_addr = self.pool.get('purchase.order.line')
        pol_id =obj_addr.search(self.cr, self.uid, [('product_qty','!=','0.0'),('order_id','=',purchase_order)])
        return obj_addr.browse(self.cr, self.uid, pol_id)
        
    
    
    def get_final_date(self):
        datetime.now().strftime('%d-%m-%Y %H:%M')
        return datetime.now().strftime('%d-%m-%Y %H:%M')
       
report_sxw.report_sxw('report.purchase.quotation.presupuesto',
    'purchase.order',
    'sisb_purchase_management/report/presupuesto.rml',
    parser=request_quotation)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
