#~ # -*- coding: utf-8 -*-
from report import report_sxw
import time
from datetime import datetime, timedelta


class comprador_report(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        
        super(comprador_report, self).__init__(cr, uid, name, context)
        self.localcontext.update(
        {
            'get_data': self._get_data,
            'get_final_date': self._get_final_date,
            'traductor': self.traductor,
            'get_empresa':self.get_empresa,

                    })
        self.context= context

    def traductor(self, palabra):
        if palabra == 'draft':
                pal='Borrador'
        if palabra == 'done':
                pal='Realizado'
        if palabra == 'approved':
                pal='Aprobado'
        if palabra == 'cancel':
                pal='Cancelado'

        return pal
            
    def _get_final_date(self):
        datetime.now().strftime('%d-%m-%Y %H:%M')
        return datetime.now().strftime('%d-%m-%Y %H:%M')

        
    def _get_data(self,form):
        d1=form['date_from']
        d2=form['date_to']
        data=[]


        self.cr.execute("""
            select t1.state, t1.amount_total, t1.user_id, 
            t1.signature, t1.country_id, t1.name,
            (select sum(user_id) from
            (SELECT a.state as state, sum(a.amount_total) as amount_total, count(b.user_id) as user_id, 
            c.signature as signature, d.country_id as country_id, e.name as name 
            from purchase_order a, purchase_requisition b, res_users c, res_partner_address d, res_country e
            where b.user_id = c.id and a.partner_address_id = d.id and d.country_id = e.id and date_order>= '%s' and date_order<='%s'
            group by c.signature, d.country_id, e.name, a.state)t1) as total, trunc(t1.user_id/(select sum(user_id) from
            (SELECT a.state as state, sum(a.amount_total) as amount_total, count(b.user_id) as user_id, 
            c.signature as signature, d.country_id as country_id, e.name as name 
            from purchase_order a, purchase_requisition b, res_users c, res_partner_address d, res_country e
            where b.user_id = c.id and a.partner_address_id = d.id and d.country_id = e.id and date_order>= '%s' and date_order<='%s'
            group by c.signature, d.country_id, e.name, a.state)t1)*100, 2) as porcentaje
            from
            (SELECT a.state as state, sum(a.amount_total) as amount_total, count(b.user_id) as user_id, 
            c.signature as signature, d.country_id as country_id, e.name as name, sum(user_id)/100
            from purchase_order a, purchase_requisition b, res_users c, res_partner_address d, res_country e
            where b.user_id = c.id and a.partner_address_id = d.id and d.country_id = e.id and date_order>= '%s' and date_order<='%s'
            group by c.signature, d.country_id, e.name, a.state)t1
        """%(d1,d2,d1,d2,d1,d2))


        data = self.cr.dictfetchall()
       
        return data
    
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
  
report_sxw.report_sxw('report.report.wizard.comprador',
                    'purchase.order',
                    parser= comprador_report,
                    #~ header= 'internal',
                    rml= 'sisb_purchase_management/report/report_wizard_comprador.rml'
                    )
