#~ # -*- coding: utf-8 -*-
from report import report_sxw
import time
from datetime import datetime, timedelta


class requisition_report(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        
        super(requisition_report, self).__init__(cr, uid, name, context)
        self.localcontext.update(
        {
            'get_data': self._get_data,
            'get_final_date': self._get_final_date,
            'time': time,
            'get_empresa':self.get_empresa,
                    })
        self.context= context


            
    def _get_final_date(self):
        datetime.now().strftime('%d-%m-%Y %H:%M')
        return datetime.now().strftime('%d-%m-%Y %H:%M')

        
    def _get_data(self,form):
        d1=form['date_from']
        d2=form['date_to']
        data=[]


        self.cr.execute("""
                select  d.name as Unidad, c.name as Descripcion, a.date_start as Fecha, b.product_qty as Cantidad, b.product_id from purchase_requisition a, purchase_requisition_line b, product_template c, product_uom d
                where a.id=b.requisition_id and c.id=b.product_id and b.product_uom_id= d.id
                and date_start>= '%s'::timestamp and date_start<='%s'::timestamp
                        
        """%(d1,d2))

        data = self.cr.dictfetchall()
        return data

    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
  
report_sxw.report_sxw('report.requisition.report.status.wizard',
                    'purchase.requisition',
                     parser= requisition_report,
                    #~ header= 'internal',
                    rml= 'sisb_purchase_management/report/requisition_status.rml'
                    )
