#~ # -*- coding: utf-8 -*-
from report import report_sxw
import time
from datetime import datetime, timedelta


class status_report(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        
        super(status_report, self).__init__(cr, uid, name, context)
        self.localcontext.update(
        {
            'get_data': self._get_data,
            'get_final_date': self._get_final_date,
            'traductor': self.traductor,
            'get_empresa':self.get_empresa,

                    })
        self.context= context


    def traductor(self, palabra):
        if palabra == 'draft':
                pal='Borrador'
        if palabra == 'done':
                pal='Realizado'
        if palabra == 'approved':
                pal='Aprobado'
        if palabra == 'cancel':
                pal='Cancelado'

        return pal

            
    def _get_final_date(self):
        datetime.now().strftime('%d-%m-%Y %H:%M')
        return datetime.now().strftime('%d-%m-%Y %H:%M')

        
    def _get_data(self,form):
        d1=form['date_from']
        d2=form['date_to']
        data=[]


        self.cr.execute("""
                SELECT  po.state as estados, count(po.id) as cantidad,
                        SUM(po.amount_total) as total, 
                        trunc((count(id)/(select count(id) from purchase_order
                        where date_order >= '%s'::timestamp
                        and date_order <= '%s'::timestamp)::float*100)::numeric, 2) as porcentaje
                        FROM purchase_order po 
                        WHERE date_order>= '%s'::timestamp and date_order<='%s'::timestamp GROUP BY state;
        """%(d1,d2,d1,d2))

        data = self.cr.dictfetchall()
        return data

    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res

  
report_sxw.report_sxw('report.comun.general.report.purchase',
                    'purchase.order',
                     parser= status_report,
                    #~ header= 'internal',
                    rml= 'sisb_purchase_management/report/reporte_status.rml'
                    )
