  # -*- coding: utf-8 -*-

from osv import osv, fields 
from tools.translate import _

class attendee_memory(osv.osv_memory):
    _name = 'openacademy.attendee.memory'
    _columns = {
        'partner_id': fields.many2one('res.partner', 'Partner',required=True),    
        'session_id': fields.many2one('openacademy.create.attendee.wizard', 'Session')
    }
attendee_memory()

class create_attendee_wizard(osv.osv_memory):
    _name = 'openacademy.create.attendee.wizard'
    _columns = {
        'session_id': fields.many2one('openacademy.session', 'Session', required=True),
        'attendee_ids' : fields.one2many('openacademy.attendee.memory', 'session_id', 'Attendees')
    }
    def action_add_attendee(self, cr, uid, ids, context=None):
        if context is None:
            context={}
        wizard_brw = self.browse(cr, uid, ids[0], context = context)
        attendee_obj = self.pool.get('openacademy.attendee')
        
        for attendee_brw in wizard_brw.attendee_ids:
            attendee_obj.create(cr, uid, 
                        {'partner_id':attendee_brw.partner_id.id,
                         'session_id':wizard_brw.session_id.id,
                                            }, context=context)

        return {
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'openacademy.session',
            'type': 'ir.actions.act_window',
            'target': 'new',
            'context': context,
            'res_id': wizard_brw.session_id.id,
            'xml_id':'openacademy.session_form_view'
        }

create_attendee_wizard()
