# -*- coding: utf-8 -*-

import time
from datetime import datetime
from dateutil.relativedelta import relativedelta

from osv import osv, fields
import netsvc
import pooler
from tools.translate import _
import decimal_precision as dp
from osv.orm import browse_record, browse_null

class tank(osv.osv):
    _name = 'stock.location'
    _inherit = 'stock.location'
    
    """
        Calculates the amount of product stored in the tank.
    """
    def _get_used_capacity(self, cr, uid, ids, field_name, args, context=None):
        res = {}
        inv_obj = self.pool.get('stock.inventory.line')
        for tank in self.browse(cr, uid, ids, context=context):
            product_qty = 0
            if tank.product_id <> None and tank.product_id <> False:
                inv_line_ids = inv_obj.search(cr, uid, ['&', ('location_id', '=',\
                 tank.id), ('product_id', '=', tank.product_id.id)])
                inv_line = inv_obj.read(cr, uid, inv_line_ids, ['product_qty'])
                for il in inv_line:
                    product_qty = il['product_qty']
            res[tank.id] = product_qty
        return res
    

    _columns = {
        'is_tank' : fields.boolean('Is tank?'),
        'capacity' : fields.float('Capacity'),
        'uom_id' : fields.many2one('product.uom', string='UoM'),
        'product_id' : fields.many2one('product.product', string='Stored Product'),
        'stock' : fields.function(_get_used_capacity, method=True, type='float',\
            store=False, string='Stock'),
    }
    
    _defaults = {
        'capacity' : 0,
    }
tank()
