# -*- coding: utf-8 -*-
"""
Módulo utilizado para incluir en la hoja de carga la funcionalidad de generar el
albarán correspondiente de acuerdo al origen del documento, si el mismo viene de
un traspaso se creará automaticamente el albarán del segmento B de la ruta a partir
del segmento A.
"""

import time
import netsvc
from osv import fields, osv
from tools import config
from tools.translate import _
import decimal_precision as dp

class hoja_de_carga(osv.osv):
    _inherit = 'hoja.de.carga'

    def action_done(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        verificado = True
        traspasos_obj = self.pool.get('traspasos')
        shipping_obj = self.pool.get('shipping.move')
        picking_obj = self.pool.get('stock.picking')
        if self.valida_done(cr, uid, ids, context=context):
            for item in self.browse(cr, uid, ids, context=context):
                aux = item.id
                pick_trapaso = False
                shipping_ids = False
                for pick in item.picking_ids:
                    traspaso_name = picking_obj.browse(cr, uid, pick.id, context=context).origin
                    pick_trapaso_search = traspasos_obj.search(cr, uid, [('name','=',traspaso_name)])
                    if pick_trapaso_search:
                        pick_trapaso = pick_trapaso_search[0]
                    if pick_trapaso:
                        shipping_ids = shipping_obj.search(cr, uid, [('traspaso_id','=',pick_trapaso),('picking_id','=',pick.id)])
                    if shipping_ids:
                        resultado = shipping_obj.validate_hoja_de_carga(cr, uid, shipping_ids, context=context)
                        if resultado['result']:
                            continue
                        else:
                            verificado = False
                if verificado:
                    for pick in item.picking_ids:
                        picking_obj.write(cr, uid, pick.id, {'hoja_carga_id':item.id})
                        traspaso_name = picking_obj.browse(cr, uid, pick.id, context=context).origin
                        pick_trapaso_search = traspasos_obj.search(cr, uid, [('name','=',traspaso_name)])
                        if pick_trapaso_search:
                            pick_trapaso = pick_trapaso_search[0]
                            traspasos_obj._get_shipping(cr, uid, pick_trapaso, False, '', context=context)
                        if pick_trapaso:
                            shipping_ids = shipping_obj.search(cr, uid, [('traspaso_id','=',pick_trapaso),('picking_id','=',pick.id)])
                        if shipping_ids:
                            resultado = shipping_obj.validate(cr, uid, shipping_ids, context=context)
                            if not resultado:
                                self.write(cr, uid, aux, {'state':'exception'}, context=context)
                                self.log(cr, uid, aux, 'Verifique los albaranes, no se ha podido procesar.')
                                return False
                            else:
                                continue
                else:
                    self.write(cr, uid, aux, {'state':'exception'}, context=context)
                    msg = resultado['msg']
                    self.log(cr, uid, aux, msg)
                    return False
        return super(hoja_de_carga, self).action_done(cr, uid, ids, context)

hoja_de_carga()
