# -*- coding: utf-8 -*-
from osv import osv, fields
import decimal_precision as dp
import netsvc
import pooler
from tools.translate import _

class account_voucher(osv.osv):
    _inherit='account.voucher'
    
    def existe_campo(self, cr, uid, modelo, nombre_campo, relacion):
        
        fields_obj = self.pool.get('ir.model.fields')
        field = fields_obj.search(cr, uid, [('name', '=', nombre_campo), ('model', '=', modelo), ('relation', '=', relacion)])
        if field:
            return True
        else:
            return False
    
    def validar_retenciones_procesadas_a_pagar(self, cr, uid, ids):
        """Funcion para validar que las facturas asociadas no se paguen
        si alguna tiene retenciones pendientes por procesar."""
        voucher_brw = self.browse(cr, uid, ids)
        #Este modulo es opcional, se verifica que este instalado antes de preguntar por el campo de retencion social
        ret_src = self.existe_campo(cr, uid, 'account.invoice', 'wh_src_id', 'account.wh.src')
       
        retenido_iva = False
        retenido_islr = False
        retenido_src = False
        
        for lineas in voucher_brw[0].line_ids:
            
            retenido_iva = lineas.invoice_id.wh_iva_id and lineas.invoice_id.wh_iva_id.state != 'done' or False

            retenido_islr = lineas.invoice_id.islr_wh_doc_id and lineas.invoice_id.islr_wh_doc_id.state != 'done' or False

            if ret_src:
                retenido_src = lineas.invoice_id.wh_src_id and lineas.invoice_id.wh_src_id.state != 'done' or False
           
            if retenido_iva or retenido_islr or retenido_src:
                return False
        
        return True
    
    #Se valida desde el workflow
    def proforma_voucher(self, cr, uid, ids, context=None):
        if self.validar_retenciones_procesadas_a_pagar(cr, uid, ids):
            return super(account_voucher, self).proforma_voucher(cr, uid, ids, context=context)
        else:
            raise osv.except_osv(_('Error!'),_("Hay facturas con retenciones pendientes por procesar. No se puede realizar el pago."))
account_voucher()

class voucher_pay_support_wizard(osv.osv_memory):
    _inherit='voucher.pay.support.wizard'
    
    #Se valida desde el wizard
    def accion_tipo(self, cr, uid, ids, context=None):
        voucher_id = context['active_id']
        obj_acc_voucher = self.pool.get('account.voucher')
        
        if obj_acc_voucher.validar_retenciones_procesadas_a_pagar(cr, uid, [voucher_id]):
            return super(voucher_pay_support_wizard, self).accion_tipo(cr, uid, ids, context)
        else:
            raise osv.except_osv(_('Error!'),_("Hay facturas con retenciones pendientes por procesar. No se puede realizar el pago."))
            
voucher_pay_support_wizard()
