#!/usr/bin/python
# -*- encoding: utf-8 -*-
###########################################################################
#    Copyright (C) Industrias Diana, C.A. (www.industriasdiana.gob.ve)
#    All Rights Reserved
###############Credits######################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################

import time
from lxml import etree
import netsvc
from osv import osv, fields
import decimal_precision as dp
from tools.translate import _
import sys 
import pooler

class sisb_batch_print(osv.osv_memory):
    _name = "sisb.batch.print"
    
    
    _columns = {
    'ctrl_number_from': fields.integer('Número Inicial',help="Número de control desde el cual se comenzara a imprimir", required=True),
                }
    
    def Imprimir(self, cr, uid, ids, context=None):
        ac_obj = self.pool.get("account.invoice")
        data = {}
        data = {
        'ids': context.get('active_ids',[]),
        'model': 'account.invoice',
        }
        print_ids = context.get('active_ids',[])
        
        ctrl_number_from = self.browse(cr, uid, ids, context)[0].ctrl_number_from
        if ctrl_number_from <= 0:
             raise osv.except_osv(_('Error!'),_("please write a valid control number!"))
        
        post_ids = ac_obj.search(cr, uid, [('id','in',context.get('active_ids',[])),('state','=','open')])
        if list(set(print_ids)-set(post_ids)):
            raise osv.except_osv(_('Error!'),_("some invoices not in state open!"))
        
        ctrl_ids = ac_obj.search(cr, uid, [('id','in',context.get('active_ids',[])),('nro_ctrl','!=','')])
        if ctrl_ids:
            raise osv.except_osv(_('Error!'),_("some invoices have a number control!"))
            
        for x in context.get('active_ids',[]):
            
            nro_control = str(ctrl_number_from)
            while (len(nro_control) < 8):
                nro_control = '0'+nro_control
                
            ac_obj.write(cr, uid, [x], {'nro_ctrl':nro_control,})
            ctrl_number_from += 1
            
        report = {'type':'ir.actions.report.xml',
        'report_name':'sisb.invoice',
        'datas':data,
        }
        return report
    
sisb_batch_print()

class account_invoice_confirm(osv.osv_memory):
    """
    This wizard will confirm the all the selected draft invoices
    """

    _inherit = "account.invoice.confirm"
    _description = "Confirm the selected invoices"
    
    _columns = {
    'ctrl_number_from': fields.integer('Número Inicial',help="Número de control desde el cual se comenzara a imprimir", required=True),
    }
    
    def invoice_confirm(self, cr, uid, ids, context=None):
        wf_service = netsvc.LocalService('workflow')
        if context is None:
            context = {}
        pool_obj = pooler.get_pool(cr.dbname)
        data_inv = pool_obj.get('account.invoice').read(cr, uid, context['active_ids'], ['state'], context=context)
        print "Esto es el Context ",context
        for record in data_inv:
            if record['state'] not in ('draft','proforma','proforma2'):
                raise osv.except_osv(_('Warning'), _("Selected Invoice(s) cannot be confirmed as they are not in 'Draft' or 'Pro-Forma' state!"))
            wf_service.trg_validate(uid, 'account.invoice', record['id'], 'invoice_open', cr)
            
        if context.get('type',False) == 'out_invoice':
            ac_obj = self.pool.get("account.invoice")
            data = {}
            data = {
            'ids': context.get('active_ids',[]),
            'model': 'account.invoice',
            }
            
            report = {'type':'ir.actions.report.xml',
            'report_name':'sisb.invoice',
            'datas':data,
            }
            
            return report
            
        return {'type': 'ir.actions.act_window_close'}
        


account_invoice_confirm()
