# -*- encoding: utf-8 -*-
##############################################################################
# Copyright (c) 2012 Industrias Diana C.A.
# All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
###############################################################################
from osv import osv
from osv import fields
import sys
from tools.translate import _
import decimal_precision as dp
import netsvc

class sisb_sale_order_wizard(osv.osv_memory):
    """
    Forzar la confirmación del presupuesto para convertirse en un pedido de venta.
    """
    _name = "sisb.sale.order.wizard"
    
    _description = "Force Confirm Sale Order"
    _columns = {
       'motivo': fields.text('Motivo', required=True),
    }
    
    def forzar_confirmar(self, cr, uid, ids, context=None):
        #obtener motivo de forzar el confirmar el presupuesto
        data_force_confirm = self.read(cr, uid, ids, [],context=context)[0]

        registro =  {
            'order_id': context['active_id'],
            'forzado': True,
            'motivo': data_force_confirm['motivo'],
            'responsable_uid': uid,
        }
        
        resultado = self.pool.get('sisb.log.forzar.presupuesto').create(cr, uid, registro, context)
        
        if not resultado:
            raise osv.except_osv(_('mensaje_usuario'),_('Hubo problemas en el proceso forzar la aprobación del presupuesto, contactar al administrador del sistema.')) 
        else:    
            #Mandar a ejecutar el workflow
            wf_service = netsvc.LocalService("workflow")
            wf_service.trg_validate(uid, 'sale.order', context['active_id'], 'order_confirm', cr)

        return {'type': 'ir.actions.act_window_close'}

sisb_sale_order_wizard()
