##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv
from tools.translate import _
import netsvc

class sale_make_invoice(osv.osv_memory):
    """
    Validaciones adicionales antes de crear facturas
    """
    _inherit = "sale.make.invoice"

    def view_init(self, cr, uid, fields_list, context=None):
        print 'context',context
        if context is None:
            context = {}
        res = super(sale_make_invoice, self).view_init(cr, uid, fields_list, context=context)
        
        record_ids = context and context.get('active_ids', False)
        orders = self.pool.get('sale.order').browse(cr, uid, record_ids, context=context)
        
        diario = [order.shop_id.journal_id.id or False for order in orders]
        if len(set(diario)) > 1:
            raise osv.except_osv(_('Warning !'),'No se puede facturar pedidos de diferentes sucursales.')
        return res

sale_make_invoice()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
