# -*- encoding: utf-8 -*-
##############################################################################
# Copyright (c) 2012 Industrias Diana C.A.
# All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
###############################################################################
from osv import fields, osv

from tools.translate import _


class stock_invoice_onshipping(osv.osv_memory):
    """
    Facturar desde el albaran utilizando por defecto el journal_id del pedido de venta.
    """
    _inherit = "stock.invoice.onshipping"
    
    
    def _sisb_get_journal_id(self, cr, uid, context=None):
        vals = super(stock_invoice_onshipping, self)._get_journal_id(cr, uid, context)
        if vals == []:
            return vals
        else:
            picking_pool = self.pool.get('stock.picking')
            active_pickings = picking_pool.browse(cr, uid, context.get('active_ids',False), context=context)
            
                        
            diario = [a_p.sale_id and a_p.sale_id.shop_id.journal_id.id or False for a_p in active_pickings]
            #el (los) albaran(es) no es(son) proveniente(s) de un pedido de venta
            if len(set(diario)) == 1 and False in diario:
                return vals
            elif len(set(diario)) > 1:
                raise osv.except_osv(_('Warning !'), _('Intenta facturar albaranes de diferentes sucursales. Por favor revisar!'))        
            elif len(set(diario)) == 1:
                #Para determinar los tipos de diarios listados
                diarios_return = [i for i,st in vals]
                tipo_diarios = [d.type for d in self.pool.get('account.journal').browse(cr, uid, diarios_return, context)]
                tipos_disponibles = list(set(tipo_diarios))
                
                #Se debe decidir cuando retornar el journal de venta o journal de refund
                if 'sale' in tipos_disponibles and len(tipos_disponibles) == 1:
                    #retorna el journal de la sucursal si se encuentra en la lista
                    journal_so = active_pickings[0] and active_pickings[0].sale_id.shop_id.journal_id.id or False
                    name_journal_so = active_pickings[0].sale_id and active_pickings[0].sale_id.shop_id.journal_id.name or False
                    for i,st in vals:
                        if journal_so == i:
                            return [(journal_so,name_journal_so)]   
                
                if 'sale_refund' in tipos_disponibles and len(tipos_disponibles) == 1:
                    #retorna el journal de la sucursal si se encuentra en la lista
                    journal_so = active_pickings[0] and active_pickings[0].sale_id.shop_id.refund_journal_id.id or False
                    name_journal_so = active_pickings[0].sale_id and active_pickings[0].sale_id.shop_id.refund_journal_id.name or False
                    for i,st in vals:
                        if journal_so == i:
                            return [(journal_so,name_journal_so)]   
                
            return vals

    _columns = {
        'journal_id': fields.selection(_sisb_get_journal_id, 'Destination Journal',required=True),
    }

stock_invoice_onshipping()
